/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.315 Revision 1.429
1# Copyright 1999-2007 Gentoo Foundation 1# Copyright 1999-2013 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.315 2009/02/21 23:28:21 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.429 2013/12/27 09:28:42 mgorny Exp $
4 4
5# @ECLASS: eutils.eclass 5# @ECLASS: eutils.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# base-system@gentoo.org 7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds 8# @BLURB: many extra (but common) functions that are used in ebuilds
13# home rather than having multiple ebuilds implementing the same thing. 13# home rather than having multiple ebuilds implementing the same thing.
14# 14#
15# Due to the nature of this eclass, some functions may have maintainers 15# Due to the nature of this eclass, some functions may have maintainers
16# different from the overall eclass! 16# different from the overall eclass!
17 17
18inherit multilib portability 18if [[ ${___ECLASS_ONCE_EUTILS} != "recur -_+^+_- spank" ]] ; then
19___ECLASS_ONCE_EUTILS="recur -_+^+_- spank"
19 20
20DESCRIPTION="Based on the ${ECLASS} eclass" 21inherit multilib toolchain-funcs user
22
23if has "${EAPI:-0}" 0 1 2; then
21 24
22# @FUNCTION: epause 25# @FUNCTION: epause
23# @USAGE: [seconds] 26# @USAGE: [seconds]
24# @DESCRIPTION: 27# @DESCRIPTION:
25# Sleep for the specified number of seconds (default of 5 seconds). Useful when 28# Sleep for the specified number of seconds (default of 5 seconds). Useful when
26# printing a message the user should probably be reading and often used in 29# printing a message the user should probably be reading and often used in
27# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set, 30# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
28# don't wait at all. 31# don't wait at all. Defined in EAPIs 0 1 and 2.
29epause() { 32epause() {
30 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5} 33 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
31} 34}
32 35
33# @FUNCTION: ebeep 36# @FUNCTION: ebeep
34# @USAGE: [number of beeps] 37# @USAGE: [number of beeps]
35# @DESCRIPTION: 38# @DESCRIPTION:
36# Issue the specified number of beeps (default of 5 beeps). Useful when 39# Issue the specified number of beeps (default of 5 beeps). Useful when
37# printing a message the user should probably be reading and often used in 40# printing a message the user should probably be reading and often used in
38# conjunction with the epause function. If the EBEEP_IGNORE env var is set, 41# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
39# don't beep at all. 42# don't beep at all. Defined in EAPIs 0 1 and 2.
40ebeep() { 43ebeep() {
41 local n 44 local n
42 if [[ -z ${EBEEP_IGNORE} ]] ; then 45 if [[ -z ${EBEEP_IGNORE} ]] ; then
43 for ((n=1 ; n <= ${1:-5} ; n++)) ; do 46 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
44 echo -ne "\a" 47 echo -ne "\a"
47 sleep 1 50 sleep 1
48 done 51 done
49 fi 52 fi
50} 53}
51 54
55else
56
57ebeep() {
58 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
59}
60
61epause() {
62 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
63}
64
65fi
66
67# @FUNCTION: eqawarn
68# @USAGE: [message]
69# @DESCRIPTION:
70# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
71# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
72# profile.
73if ! declare -F eqawarn >/dev/null ; then
74 eqawarn() {
75 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
76 :
77 }
78fi
79
52# @FUNCTION: ecvs_clean 80# @FUNCTION: ecvs_clean
53# @USAGE: [list of dirs] 81# @USAGE: [list of dirs]
54# @DESCRIPTION: 82# @DESCRIPTION:
55# Remove CVS directories recursiveley. Useful when a source tarball contains 83# Remove CVS directories recursiveley. Useful when a source tarball contains
56# internal CVS directories. Defaults to $PWD. 84# internal CVS directories. Defaults to $PWD.
68esvn_clean() { 96esvn_clean() {
69 [[ -z $* ]] && set -- . 97 [[ -z $* ]] && set -- .
70 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf 98 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
71} 99}
72 100
73# Default directory where patches are located 101# @FUNCTION: estack_push
102# @USAGE: <stack> [items to push]
103# @DESCRIPTION:
104# Push any number of items onto the specified stack. Pick a name that
105# is a valid variable (i.e. stick to alphanumerics), and push as many
106# items as you like onto the stack at once.
107#
108# The following code snippet will echo 5, then 4, then 3, then ...
109# @CODE
110# estack_push mystack 1 2 3 4 5
111# while estack_pop mystack i ; do
112# echo "${i}"
113# done
114# @CODE
115estack_push() {
116 [[ $# -eq 0 ]] && die "estack_push: incorrect # of arguments"
117 local stack_name="__ESTACK_$1__" ; shift
118 eval ${stack_name}+=\( \"\$@\" \)
119}
120
121# @FUNCTION: estack_pop
122# @USAGE: <stack> [variable]
123# @DESCRIPTION:
124# Pop a single item off the specified stack. If a variable is specified,
125# the popped item is stored there. If no more items are available, return
126# 1, else return 0. See estack_push for more info.
127estack_pop() {
128 [[ $# -eq 0 || $# -gt 2 ]] && die "estack_pop: incorrect # of arguments"
129
130 # We use the fugly __estack_xxx var names to avoid collision with
131 # passing back the return value. If we used "local i" and the
132 # caller ran `estack_pop ... i`, we'd end up setting the local
133 # copy of "i" rather than the caller's copy. The __estack_xxx
134 # garbage is preferable to using $1/$2 everywhere as that is a
135 # bit harder to read.
136 local __estack_name="__ESTACK_$1__" ; shift
137 local __estack_retvar=$1 ; shift
138 eval local __estack_i=\${#${__estack_name}\[@\]}
139 # Don't warn -- let the caller interpret this as a failure
140 # or as normal behavior (akin to `shift`)
141 [[ $(( --__estack_i )) -eq -1 ]] && return 1
142
143 if [[ -n ${__estack_retvar} ]] ; then
144 eval ${__estack_retvar}=\"\${${__estack_name}\[${__estack_i}\]}\"
145 fi
146 eval unset ${__estack_name}\[${__estack_i}\]
147}
148
149# @FUNCTION: evar_push
150# @USAGE: <variable to save> [more vars to save]
151# @DESCRIPTION:
152# This let's you temporarily modify a variable and then restore it (including
153# set vs unset semantics). Arrays are not supported at this time.
154#
155# This is meant for variables where using `local` does not work (such as
156# exported variables, or only temporarily changing things in a func).
157#
158# For example:
159# @CODE
160# evar_push LC_ALL
161# export LC_ALL=C
162# ... do some stuff that needs LC_ALL=C set ...
163# evar_pop
164#
165# # You can also save/restore more than one var at a time
166# evar_push BUTTERFLY IN THE SKY
167# ... do stuff with the vars ...
168# evar_pop # This restores just one var, SKY
169# ... do more stuff ...
170# evar_pop 3 # This pops the remaining 3 vars
171# @CODE
172evar_push() {
173 local var val
174 for var ; do
175 [[ ${!var+set} == "set" ]] \
176 && val=${!var} \
177 || val="${___ECLASS_ONCE_EUTILS}"
178 estack_push evar "${var}" "${val}"
179 done
180}
181
182# @FUNCTION: evar_push_set
183# @USAGE: <variable to save> [new value to store]
184# @DESCRIPTION:
185# This is a handy shortcut to save and temporarily set a variable. If a value
186# is not specified, the var will be unset.
187evar_push_set() {
188 local var=$1
189 evar_push ${var}
190 case $# in
191 1) unset ${var} ;;
192 2) printf -v "${var}" '%s' "$2" ;;
193 *) die "${FUNCNAME}: incorrect # of args: $*" ;;
194 esac
195}
196
197# @FUNCTION: evar_pop
198# @USAGE: [number of vars to restore]
199# @DESCRIPTION:
200# Restore the variables to the state saved with the corresponding
201# evar_push call. See that function for more details.
202evar_pop() {
203 local cnt=${1:-bad}
204 case $# in
205 0) cnt=1 ;;
206 1) isdigit "${cnt}" || die "${FUNCNAME}: first arg must be a number: $*" ;;
207 *) die "${FUNCNAME}: only accepts one arg: $*" ;;
208 esac
209
210 local var val
211 while (( cnt-- )) ; do
212 estack_pop evar val || die "${FUNCNAME}: unbalanced push"
213 estack_pop evar var || die "${FUNCNAME}: unbalanced push"
214 [[ ${val} == "${___ECLASS_ONCE_EUTILS}" ]] \
215 && unset ${var} \
216 || printf -v "${var}" '%s' "${val}"
217 done
218}
219
220# @FUNCTION: eshopts_push
221# @USAGE: [options to `set` or `shopt`]
222# @DESCRIPTION:
223# Often times code will want to enable a shell option to change code behavior.
224# Since changing shell options can easily break other pieces of code (which
225# assume the default state), eshopts_push is used to (1) push the current shell
226# options onto a stack and (2) pass the specified arguments to set.
227#
228# If the first argument is '-s' or '-u', we assume you want to call `shopt`
229# rather than `set` as there are some options only available via that.
230#
231# A common example is to disable shell globbing so that special meaning/care
232# may be used with variables/arguments to custom functions. That would be:
233# @CODE
234# eshopts_push -s noglob
235# for x in ${foo} ; do
236# if ...some check... ; then
237# eshopts_pop
238# return 0
239# fi
240# done
241# eshopts_pop
242# @CODE
243eshopts_push() {
244 if [[ $1 == -[su] ]] ; then
245 estack_push eshopts "$(shopt -p)"
246 [[ $# -eq 0 ]] && return 0
247 shopt "$@" || die "${FUNCNAME}: bad options to shopt: $*"
248 else
249 estack_push eshopts $-
250 [[ $# -eq 0 ]] && return 0
251 set "$@" || die "${FUNCNAME}: bad options to set: $*"
252 fi
253}
254
255# @FUNCTION: eshopts_pop
256# @USAGE:
257# @DESCRIPTION:
258# Restore the shell options to the state saved with the corresponding
259# eshopts_push call. See that function for more details.
260eshopts_pop() {
261 local s
262 estack_pop eshopts s || die "${FUNCNAME}: unbalanced push"
263 if [[ ${s} == "shopt -"* ]] ; then
264 eval "${s}" || die "${FUNCNAME}: sanity: invalid shopt options: ${s}"
265 else
266 set +$- || die "${FUNCNAME}: sanity: invalid shell settings: $-"
267 set -${s} || die "${FUNCNAME}: sanity: unable to restore saved shell settings: ${s}"
268 fi
269}
270
271# @FUNCTION: eumask_push
272# @USAGE: <new umask>
273# @DESCRIPTION:
274# Set the umask to the new value specified while saving the previous
275# value onto a stack. Useful for temporarily changing the umask.
276eumask_push() {
277 estack_push eumask "$(umask)"
278 umask "$@" || die "${FUNCNAME}: bad options to umask: $*"
279}
280
281# @FUNCTION: eumask_pop
282# @USAGE:
283# @DESCRIPTION:
284# Restore the previous umask state.
285eumask_pop() {
286 [[ $# -eq 0 ]] || die "${FUNCNAME}: we take no options"
287 local s
288 estack_pop eumask s || die "${FUNCNAME}: unbalanced push"
289 umask ${s} || die "${FUNCNAME}: sanity: could not restore umask: ${s}"
290}
291
292# @FUNCTION: isdigit
293# @USAGE: <number> [more numbers]
294# @DESCRIPTION:
295# Return true if all arguments are numbers.
296isdigit() {
297 local d
298 for d ; do
299 [[ ${d:-bad} == *[!0-9]* ]] && return 1
300 done
301 return 0
302}
303
304# @VARIABLE: EPATCH_SOURCE
305# @DESCRIPTION:
306# Default directory to search for patches.
74EPATCH_SOURCE="${WORKDIR}/patch" 307EPATCH_SOURCE="${WORKDIR}/patch"
75# Default extension for patches 308# @VARIABLE: EPATCH_SUFFIX
309# @DESCRIPTION:
310# Default extension for patches (do not prefix the period yourself).
76EPATCH_SUFFIX="patch.bz2" 311EPATCH_SUFFIX="patch.bz2"
77# Default options for patch 312# @VARIABLE: EPATCH_OPTS
313# @DESCRIPTION:
314# Options to pass to patch. Meant for ebuild/package-specific tweaking
315# such as forcing the patch level (-p#) or fuzz (-F#) factor. Note that
316# for single patch tweaking, you can also pass flags directly to epatch.
317EPATCH_OPTS=""
318# @VARIABLE: EPATCH_COMMON_OPTS
319# @DESCRIPTION:
320# Common options to pass to `patch`. You probably should never need to
321# change these. If you do, please discuss it with base-system first to
322# be sure.
323# @CODE
78# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 324# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
79# Set --no-backup-if-mismatch so we don't leave '.orig' files behind. 325# --no-backup-if-mismatch - do not leave .orig files behind
80# Set -E to automatically remove empty files. 326# -E - automatically remove empty files
327# @CODE
81EPATCH_OPTS="-g0 -E --no-backup-if-mismatch" 328EPATCH_COMMON_OPTS="-g0 -E --no-backup-if-mismatch"
329# @VARIABLE: EPATCH_EXCLUDE
330# @DESCRIPTION:
82# List of patches not to apply. Note this is only file names, 331# List of patches not to apply. Note this is only file names,
83# and not the full path .. 332# and not the full path. Globs accepted.
84EPATCH_EXCLUDE="" 333EPATCH_EXCLUDE=""
334# @VARIABLE: EPATCH_SINGLE_MSG
335# @DESCRIPTION:
85# Change the printed message for a single patch. 336# Change the printed message for a single patch.
86EPATCH_SINGLE_MSG="" 337EPATCH_SINGLE_MSG=""
338# @VARIABLE: EPATCH_MULTI_MSG
339# @DESCRIPTION:
87# Change the printed message for multiple patches. 340# Change the printed message for multiple patches.
88EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..." 341EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
89# Force applying bulk patches even if not following the style: 342# @VARIABLE: EPATCH_FORCE
90# 343# @DESCRIPTION:
91# ??_${ARCH}_foo.${EPATCH_SUFFIX} 344# Only require patches to match EPATCH_SUFFIX rather than the extended
92# 345# arch naming style.
93EPATCH_FORCE="no" 346EPATCH_FORCE="no"
347# @VARIABLE: EPATCH_USER_EXCLUDE
348# @DEFAULT_UNSET
349# @DESCRIPTION:
350# List of patches not to apply. Note this is only file names,
351# and not the full path. Globs accepted.
94 352
95# This function is for bulk patching, or in theory for just one 353# @FUNCTION: epatch
96# or two patches. 354# @USAGE: [options] [patches] [dirs of patches]
355# @DESCRIPTION:
356# epatch is designed to greatly simplify the application of patches. It can
357# process patch files directly, or directories of patches. The patches may be
358# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
359# the -p option as epatch will automatically attempt -p0 to -p4 until things
360# apply successfully.
97# 361#
98# It should work with .bz2, .gz, .zip and plain text patches. 362# If you do not specify any patches/dirs, then epatch will default to the
99# Currently all patches should be the same format. 363# directory specified by EPATCH_SOURCE.
100# 364#
101# You do not have to specify '-p' option to patch, as it will 365# Any options specified that start with a dash will be passed down to patch
102# try with -p0 to -p5 until it succeed, or fail at -p5. 366# for this specific invocation. As soon as an arg w/out a dash is found, then
367# arg processing stops.
103# 368#
104# Above EPATCH_* variables can be used to control various defaults, 369# When processing directories, epatch will apply all patches that match:
105# bug they should be left as is to ensure an ebuild can rely on 370# @CODE
106# them for. 371# if ${EPATCH_FORCE} != "yes"
107#
108# Patches are applied in current directory.
109#
110# Bulk Patches should preferably have the form of:
111#
112# ??_${ARCH}_foo.${EPATCH_SUFFIX} 372# ??_${ARCH}_foo.${EPATCH_SUFFIX}
373# else
374# *.${EPATCH_SUFFIX}
375# @CODE
376# The leading ?? are typically numbers used to force consistent patch ordering.
377# The arch field is used to apply patches only for the host architecture with
378# the special value of "all" means apply for everyone. Note that using values
379# other than "all" is highly discouraged -- you should apply patches all the
380# time and let architecture details be detected at configure/compile time.
113# 381#
114# For example: 382# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
383# for patches to apply.
115# 384#
116# 01_all_misc-fix.patch.bz2 385# Refer to the other EPATCH_xxx variables for more customization of behavior.
117# 02_sparc_another-fix.patch.bz2
118#
119# This ensures that there are a set order, and you can have ARCH
120# specific patches.
121#
122# If you however give an argument to epatch(), it will treat it as a
123# single patch that need to be applied if its a file. If on the other
124# hand its a directory, it will set EPATCH_SOURCE to this.
125#
126# <azarah@gentoo.org> (10 Nov 2002)
127#
128epatch() { 386epatch() {
129 _epatch_draw_line() { 387 _epatch_draw_line() {
388 # create a line of same length as input string
130 [[ -z $1 ]] && set "$(printf "%65s" '')" 389 [[ -z $1 ]] && set "$(printf "%65s" '')"
131 echo "${1//?/=}" 390 echo "${1//?/=}"
132 } 391 }
133 _epatch_assert() { local _pipestatus=${PIPESTATUS[*]}; [[ ${_pipestatus// /} -eq 0 ]] ; }
134 local PIPE_CMD=""
135 local STDERR_TARGET="${T}/$$.out"
136 local PATCH_TARGET="${T}/$$.patch"
137 local PATCH_SUFFIX=""
138 local SINGLE_PATCH="no"
139 local x=""
140 392
141 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402 393 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
142 394
143 if [ "$#" -gt 1 ] 395 # First process options. We localize the EPATCH_OPTS setting
144 then 396 # from above so that we can pass it on in the loop below with
397 # any additional values the user has specified.
398 local EPATCH_OPTS=( ${EPATCH_OPTS[*]} )
399 while [[ $# -gt 0 ]] ; do
400 case $1 in
401 -*) EPATCH_OPTS+=( "$1" ) ;;
402 *) break ;;
403 esac
404 shift
405 done
406
407 # Let the rest of the code process one user arg at a time --
408 # each arg may expand into multiple patches, and each arg may
409 # need to start off with the default global EPATCH_xxx values
410 if [[ $# -gt 1 ]] ; then
145 local m="" 411 local m
146 for m in "$@" ; do 412 for m in "$@" ; do
147 epatch "${m}" 413 epatch "${m}"
148 done 414 done
149 return 0 415 return 0
150 fi 416 fi
151 417
152 if [ -n "$1" -a -f "$1" ] 418 local SINGLE_PATCH="no"
153 then 419 # no args means process ${EPATCH_SOURCE}
420 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
421
422 if [[ -f $1 ]] ; then
154 SINGLE_PATCH="yes" 423 SINGLE_PATCH="yes"
155 424 set -- "$1"
156 local EPATCH_SOURCE="$1" 425 # Use the suffix from the single patch (localize it); the code
426 # below will find the suffix for us
157 local EPATCH_SUFFIX="${1##*\.}" 427 local EPATCH_SUFFIX=$1
158 428
159 elif [ -n "$1" -a -d "$1" ] 429 elif [[ -d $1 ]] ; then
160 then 430 # We have to force sorting to C so that the wildcard expansion is consistent #471666.
161 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 431 evar_push_set LC_COLLATE C
162 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 432 # Some people like to make dirs of patches w/out suffixes (vim).
433 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
434 evar_pop
435
436 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
437 # Re-use EPATCH_SOURCE as a search dir
438 epatch "${EPATCH_SOURCE}/$1"
439 return $?
440
441 else
442 # sanity check ... if it isn't a dir or file, wtf man ?
443 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
444 echo
445 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
446 eerror
447 eerror " ${EPATCH_SOURCE}"
448 eerror " ( ${EPATCH_SOURCE##*/} )"
449 echo
450 die "Cannot find \$EPATCH_SOURCE!"
451 fi
452
453 # Now that we know we're actually going to apply something, merge
454 # all of the patch options back in to a single variable for below.
455 EPATCH_OPTS="${EPATCH_COMMON_OPTS} ${EPATCH_OPTS[*]}"
456
457 local PIPE_CMD
458 case ${EPATCH_SUFFIX##*\.} in
459 xz) PIPE_CMD="xz -dc" ;;
460 lzma) PIPE_CMD="lzma -dc" ;;
461 bz2) PIPE_CMD="bzip2 -dc" ;;
462 gz|Z|z) PIPE_CMD="gzip -dc" ;;
463 ZIP|zip) PIPE_CMD="unzip -p" ;;
464 *) ;;
465 esac
466
467 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
468
469 local x
470 for x in "$@" ; do
471 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
472 # didn't match anything, ignore continue on
473 [[ ! -f ${x} ]] && continue
474
475 local patchname=${x##*/}
476
477 # Apply single patches, or forced sets of patches, or
478 # patches with ARCH dependant names.
479 # ???_arch_foo.patch
480 # Else, skip this input altogether
481 local a=${patchname#*_} # strip the ???_
482 a=${a%%_*} # strip the _foo.patch
483 if ! [[ ${SINGLE_PATCH} == "yes" || \
484 ${EPATCH_FORCE} == "yes" || \
485 ${a} == all || \
486 ${a} == ${ARCH} ]]
163 then 487 then
164 local EPATCH_SOURCE="$1/*" 488 continue
489 fi
490
491 # Let people filter things dynamically
492 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
493 # let people use globs in the exclude
494 eshopts_push -o noglob
495
496 local ex
497 for ex in ${EPATCH_EXCLUDE} ; do
498 if [[ ${patchname} == ${ex} ]] ; then
499 einfo " Skipping ${patchname} due to EPATCH_EXCLUDE ..."
500 eshopts_pop
501 continue 2
502 fi
503 done
504
505 for ex in ${EPATCH_USER_EXCLUDE} ; do
506 if [[ ${patchname} == ${ex} ]] ; then
507 einfo " Skipping ${patchname} due to EPATCH_USER_EXCLUDE ..."
508 eshopts_pop
509 continue 2
510 fi
511 done
512
513 eshopts_pop
514 fi
515
516 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
517 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
518 einfo "${EPATCH_SINGLE_MSG}"
519 else
520 einfo "Applying ${patchname} ..."
521 fi
165 else 522 else
166 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 523 einfo " ${patchname} ..."
167 fi 524 fi
168 else 525
169 if [[ ! -d ${EPATCH_SOURCE} ]] || [[ -n $1 ]] ; then 526 # most of the time, there will only be one run per unique name,
170 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 527 # but if there are more, make sure we get unique log filenames
171 then 528 local STDERR_TARGET="${T}/${patchname}.out"
172 EPATCH_SOURCE="$1" 529 if [[ -e ${STDERR_TARGET} ]] ; then
530 STDERR_TARGET="${T}/${patchname}-$$.out"
531 fi
532
533 printf "***** %s *****\nPWD: %s\n\n" "${patchname}" "${PWD}" > "${STDERR_TARGET}"
534
535 # Decompress the patch if need be
536 local count=0
537 local PATCH_TARGET
538 if [[ -n ${PIPE_CMD} ]] ; then
539 PATCH_TARGET="${T}/$$.patch"
540 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
541
542 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
543 echo
544 eerror "Could not extract patch!"
545 #die "Could not extract patch!"
546 count=5
547 break
173 fi 548 fi
549 else
550 PATCH_TARGET=${x}
551 fi
174 552
553 # Check for absolute paths in patches. If sandbox is disabled,
554 # people could (accidently) patch files in the root filesystem.
555 # Or trigger other unpleasantries #237667. So disallow -p0 on
556 # such patches.
557 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
558 if [[ -n ${abs_paths} ]] ; then
559 count=1
560 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
561 fi
562 # Similar reason, but with relative paths.
563 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
564 if [[ -n ${rel_paths} ]] ; then
175 echo 565 echo
176 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 566 eerror "Rejected Patch: ${patchname} !"
567 eerror " ( ${PATCH_TARGET} )"
177 eerror 568 eerror
178 eerror " ${EPATCH_SOURCE}" 569 eerror "Your patch uses relative paths '../':"
179 eerror " ( ${EPATCH_SOURCE##*/} )" 570 eerror "${rel_paths}"
180 echo 571 echo
181 die "Cannot find \$EPATCH_SOURCE!" 572 die "you need to fix the relative paths in patch"
182 fi
183
184 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
185 fi 573 fi
186 574
187 case ${EPATCH_SUFFIX##*\.} in 575 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
188 lzma) 576 local patch_cmd
189 PIPE_CMD="lzma -dc" 577 # Handle aliased patch command #404447 #461568
190 PATCH_SUFFIX="lzma" 578 local patch="patch"
191 ;; 579 eval $(alias patch 2>/dev/null | sed 's:^alias ::')
192 bz2) 580 while [[ ${count} -lt 5 ]] ; do
193 PIPE_CMD="bzip2 -dc" 581 patch_cmd="${patch} -p${count} ${EPATCH_OPTS}"
194 PATCH_SUFFIX="bz2"
195 ;;
196 gz|Z|z)
197 PIPE_CMD="gzip -dc"
198 PATCH_SUFFIX="gz"
199 ;;
200 ZIP|zip)
201 PIPE_CMD="unzip -p"
202 PATCH_SUFFIX="zip"
203 ;;
204 *)
205 PIPE_CMD="cat"
206 PATCH_SUFFIX="patch"
207 ;;
208 esac
209 582
210 if [ "${SINGLE_PATCH}" = "no" ] 583 # Generate some useful debug info ...
211 then 584 (
212 einfo "${EPATCH_MULTI_MSG}" 585 _epatch_draw_line "***** ${patchname} *****"
213 fi 586 echo
214 for x in ${EPATCH_SOURCE} 587 echo "PATCH COMMAND: ${patch_cmd} < '${PATCH_TARGET}'"
215 do 588 echo
216 # New ARCH dependant patch naming scheme ... 589 _epatch_draw_line "***** ${patchname} *****"
217 # 590 ${patch_cmd} --dry-run -f < "${PATCH_TARGET}" 2>&1
218 # ???_arch_foo.patch 591 ret=$?
219 # 592 echo
220 if [ -f ${x} ] && \ 593 echo "patch program exited with status ${ret}"
221 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "${x/_${ARCH}_}" != "${x}" ] || \ 594 exit ${ret}
222 [ "${EPATCH_FORCE}" = "yes" ]) 595 ) >> "${STDERR_TARGET}"
223 then
224 local count=0
225 local popts="${EPATCH_OPTS}"
226 local patchname=${x##*/}
227 596
228 if [ -n "${EPATCH_EXCLUDE}" ] 597 if [ $? -eq 0 ] ; then
229 then 598 (
230 if [ "${EPATCH_EXCLUDE/${patchname}}" != "${EPATCH_EXCLUDE}" ] 599 _epatch_draw_line "***** ${patchname} *****"
231 then 600 echo
232 continue 601 echo "ACTUALLY APPLYING ${patchname} ..."
602 echo
603 _epatch_draw_line "***** ${patchname} *****"
604 ${patch_cmd} < "${PATCH_TARGET}" 2>&1
605 ret=$?
606 echo
607 echo "patch program exited with status ${ret}"
608 exit ${ret}
609 ) >> "${STDERR_TARGET}"
610
611 if [ $? -ne 0 ] ; then
612 echo
613 eerror "A dry-run of patch command succeeded, but actually"
614 eerror "applying the patch failed!"
615 #die "Real world sux compared to the dreamworld!"
616 count=5
233 fi 617 fi
618 break
234 fi 619 fi
235 620
236 if [ "${SINGLE_PATCH}" = "yes" ] 621 : $(( count++ ))
237 then
238 if [ -n "${EPATCH_SINGLE_MSG}" ]
239 then
240 einfo "${EPATCH_SINGLE_MSG}"
241 else
242 einfo "Applying ${patchname} ..."
243 fi
244 else
245 einfo " ${patchname} ..."
246 fi
247
248 echo "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
249 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
250
251 # Decompress the patch if need be
252 if [[ ${PATCH_SUFFIX} != "patch" ]] ; then
253 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
254 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
255
256 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1 ; then
257 echo
258 eerror "Could not extract patch!"
259 #die "Could not extract patch!"
260 count=5
261 break
262 fi
263 else
264 PATCH_TARGET="${x}"
265 fi
266
267 # Check for absolute paths in patches. If sandbox is disabled,
268 # people could (accidently) patch files in the root filesystem.
269 # Or trigger other unpleasantries #237667. So disallow -p0 on
270 # such patches.
271 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
272 if [[ -n ${abs_paths} ]] ; then
273 count=1
274 echo "NOTE: skipping -p0 due to absolute paths in patch:" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
275 echo "${abs_paths}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
276 fi
277
278 # Allow for prefix to differ ... im lazy, so shoot me :/
279 while [ "${count}" -lt 5 ]
280 do
281 # Generate some useful debug info ...
282 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
283 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
284
285 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
286 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
287
288 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
289 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
290
291 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f ; _epatch_assert) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
292 then
293 _epatch_draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
294 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
295 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
296 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
297 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
298
299 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
300 _epatch_assert
301
302 if [ "$?" -ne 0 ]
303 then
304 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
305 echo
306 eerror "A dry-run of patch command succeeded, but actually"
307 eerror "applying the patch failed!"
308 #die "Real world sux compared to the dreamworld!"
309 count=5
310 fi
311
312 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
313
314 break
315 fi
316
317 count=$((count + 1))
318 done 622 done
319 623
320 if [ "${PATCH_SUFFIX}" != "patch" ] 624 # if we had to decompress the patch, delete the temp one
321 then 625 if [[ -n ${PIPE_CMD} ]] ; then
322 rm -f ${PATCH_TARGET} 626 rm -f "${PATCH_TARGET}"
323 fi 627 fi
324 628
325 if [ "${count}" -eq 5 ] 629 if [[ ${count} -ge 5 ]] ; then
326 then
327 echo 630 echo
328 eerror "Failed Patch: ${patchname} !" 631 eerror "Failed Patch: ${patchname} !"
329 eerror " ( ${PATCH_TARGET} )" 632 eerror " ( ${PATCH_TARGET} )"
330 eerror 633 eerror
331 eerror "Include in your bugreport the contents of:" 634 eerror "Include in your bugreport the contents of:"
332 eerror 635 eerror
333 eerror " ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}" 636 eerror " ${STDERR_TARGET}"
334 echo 637 echo
335 die "Failed Patch: ${patchname}!" 638 die "Failed Patch: ${patchname}!"
336 fi 639 fi
337 640
338 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 641 # if everything worked, delete the full debug patch log
642 rm -f "${STDERR_TARGET}"
339 643
644 # then log away the exact stuff for people to review later
645 cat <<-EOF >> "${T}/epatch.log"
646 PATCH: ${x}
647 CMD: ${patch_cmd}
648 PWD: ${PWD}
649
650 EOF
340 eend 0 651 eend 0
341 fi
342 done 652 done
343 if [ "${SINGLE_PATCH}" = "no" ] 653
344 then 654 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
345 einfo "Done with patching" 655 : # everything worked
656}
657
658# @FUNCTION: epatch_user
659# @USAGE:
660# @DESCRIPTION:
661# Applies user-provided patches to the source tree. The patches are
662# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>[:SLOT]/, where the first
663# of these three directories to exist will be the one to use, ignoring
664# any more general directories which might exist as well. They must end
665# in ".patch" to be applied.
666#
667# User patches are intended for quick testing of patches without ebuild
668# modifications, as well as for permanent customizations a user might
669# desire. Obviously, there can be no official support for arbitrarily
670# patched ebuilds. So whenever a build log in a bug report mentions that
671# user patches were applied, the user should be asked to reproduce the
672# problem without these.
673#
674# Not all ebuilds do call this function, so placing patches in the
675# stated directory might or might not work, depending on the package and
676# the eclasses it inherits and uses. It is safe to call the function
677# repeatedly, so it is always possible to add a call at the ebuild
678# level. The first call is the time when the patches will be
679# applied.
680#
681# Ideally, this function should be called after gentoo-specific patches
682# have been applied, so that their code can be modified as well, but
683# before calls to e.g. eautoreconf, as the user patches might affect
684# autotool input files as well.
685epatch_user() {
686 [[ $# -ne 0 ]] && die "epatch_user takes no options"
687
688 # Allow multiple calls to this function; ignore all but the first
689 local applied="${T}/epatch_user.log"
690 [[ -e ${applied} ]] && return 2
691
692 # don't clobber any EPATCH vars that the parent might want
693 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
694 for check in ${CATEGORY}/{${P}-${PR},${P},${PN}}{,:${SLOT}}; do
695 EPATCH_SOURCE=${base}/${CTARGET}/${check}
696 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
697 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
698 if [[ -d ${EPATCH_SOURCE} ]] ; then
699 EPATCH_SOURCE=${EPATCH_SOURCE} \
700 EPATCH_SUFFIX="patch" \
701 EPATCH_FORCE="yes" \
702 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
703 epatch
704 echo "${EPATCH_SOURCE}" > "${applied}"
705 return 0
346 fi 706 fi
707 done
708 echo "none" > "${applied}"
709 return 1
347} 710}
348 711
349# @FUNCTION: emktemp 712# @FUNCTION: emktemp
350# @USAGE: [temp dir] 713# @USAGE: [temp dir]
351# @DESCRIPTION: 714# @DESCRIPTION:
379 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX 742 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
380 fi 743 fi
381 fi 744 fi
382} 745}
383 746
384# @FUNCTION: egetent
385# @USAGE: <database> <key>
386# @MAINTAINER:
387# base-system@gentoo.org (Linux)
388# Joe Jezak <josejx@gmail.com> (OS X)
389# usata@gentoo.org (OS X)
390# Aaron Walker <ka0ttic@gentoo.org> (FreeBSD)
391# @DESCRIPTION:
392# Small wrapper for getent (Linux),
393# nidump (< Mac OS X 10.5), dscl (Mac OS X 10.5),
394# and pw (FreeBSD) used in enewuser()/enewgroup()
395egetent() {
396 case ${CHOST} in
397 *-darwin9)
398 local mytype=$1
399 [[ "passwd" == $mytype ]] && mytype="Users"
400 [[ "group" == $mytype ]] && mytype="Groups"
401 case "$2" in
402 *[!0-9]*) # Non numeric
403 dscl . -read /$mytype/$2 2>/dev/null |grep RecordName
404 ;;
405 *) # Numeric
406 local mykey="UniqueID"
407 [[ $mytype == "Groups" ]] && mykey="PrimaryGroupID"
408 dscl . -search /$mytype $mykey $2 2>/dev/null
409 ;;
410 esac
411 ;;
412 *-darwin*)
413 case "$2" in
414 *[!0-9]*) # Non numeric
415 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
416 ;;
417 *) # Numeric
418 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
419 ;;
420 esac
421 ;;
422 *-freebsd*|*-dragonfly*)
423 local opts action="user"
424 [[ $1 == "passwd" ]] || action="group"
425
426 # lookup by uid/gid
427 if [[ $2 == [[:digit:]]* ]] ; then
428 [[ ${action} == "user" ]] && opts="-u" || opts="-g"
429 fi
430
431 pw show ${action} ${opts} "$2" -q
432 ;;
433 *-netbsd*|*-openbsd*)
434 grep "$2:\*:" /etc/$1
435 ;;
436 *)
437 type -p nscd >& /dev/null && nscd -i "$1"
438 getent "$1" "$2"
439 ;;
440 esac
441}
442
443# @FUNCTION: enewuser
444# @USAGE: <user> [uid] [shell] [homedir] [groups] [params]
445# @DESCRIPTION:
446# Same as enewgroup, you are not required to understand how to properly add
447# a user to the system. The only required parameter is the username.
448# Default uid is (pass -1 for this) next available, default shell is
449# /bin/false, default homedir is /dev/null, there are no default groups,
450# and default params sets the comment as 'added by portage for ${PN}'.
451enewuser() {
452 case ${EBUILD_PHASE} in
453 unpack|compile|test|install)
454 eerror "'enewuser()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
455 eerror "Package fails at QA and at life. Please file a bug."
456 die "Bad package! enewuser is only for use in pkg_* functions!"
457 esac
458
459 # get the username
460 local euser=$1; shift
461 if [[ -z ${euser} ]] ; then
462 eerror "No username specified !"
463 die "Cannot call enewuser without a username"
464 fi
465
466 # lets see if the username already exists
467 if [[ -n $(egetent passwd "${euser}") ]] ; then
468 return 0
469 fi
470 einfo "Adding user '${euser}' to your system ..."
471
472 # options to pass to useradd
473 local opts=
474
475 # handle uid
476 local euid=$1; shift
477 if [[ -n ${euid} && ${euid} != -1 ]] ; then
478 if [[ ${euid} -gt 0 ]] ; then
479 if [[ -n $(egetent passwd ${euid}) ]] ; then
480 euid="next"
481 fi
482 else
483 eerror "Userid given but is not greater than 0 !"
484 die "${euid} is not a valid UID"
485 fi
486 else
487 euid="next"
488 fi
489 if [[ ${euid} == "next" ]] ; then
490 for ((euid = 101; euid <= 999; euid++)); do
491 [[ -z $(egetent passwd ${euid}) ]] && break
492 done
493 fi
494 opts="${opts} -u ${euid}"
495 einfo " - Userid: ${euid}"
496
497 # handle shell
498 local eshell=$1; shift
499 if [[ ! -z ${eshell} ]] && [[ ${eshell} != "-1" ]] ; then
500 if [[ ! -e ${ROOT}${eshell} ]] ; then
501 eerror "A shell was specified but it does not exist !"
502 die "${eshell} does not exist in ${ROOT}"
503 fi
504 if [[ ${eshell} == */false || ${eshell} == */nologin ]] ; then
505 eerror "Do not specify ${eshell} yourself, use -1"
506 die "Pass '-1' as the shell parameter"
507 fi
508 else
509 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
510 [[ -x ${ROOT}${shell} ]] && break
511 done
512
513 if [[ ${shell} == "/dev/null" ]] ; then
514 eerror "Unable to identify the shell to use, proceeding with userland default."
515 case ${USERLAND} in
516 GNU) shell="/bin/false" ;;
517 BSD) shell="/sbin/nologin" ;;
518 Darwin) shell="/usr/sbin/nologin" ;;
519 *) die "Unable to identify the default shell for userland ${USERLAND}"
520 esac
521 fi
522
523 eshell=${shell}
524 fi
525 einfo " - Shell: ${eshell}"
526 opts="${opts} -s ${eshell}"
527
528 # handle homedir
529 local ehome=$1; shift
530 if [[ -z ${ehome} ]] || [[ ${ehome} == "-1" ]] ; then
531 ehome="/dev/null"
532 fi
533 einfo " - Home: ${ehome}"
534 opts="${opts} -d ${ehome}"
535
536 # handle groups
537 local egroups=$1; shift
538 if [[ ! -z ${egroups} ]] ; then
539 local oldifs=${IFS}
540 local defgroup="" exgroups=""
541
542 export IFS=","
543 for g in ${egroups} ; do
544 export IFS=${oldifs}
545 if [[ -z $(egetent group "${g}") ]] ; then
546 eerror "You must add group ${g} to the system first"
547 die "${g} is not a valid GID"
548 fi
549 if [[ -z ${defgroup} ]] ; then
550 defgroup=${g}
551 else
552 exgroups="${exgroups},${g}"
553 fi
554 export IFS=","
555 done
556 export IFS=${oldifs}
557
558 opts="${opts} -g ${defgroup}"
559 if [[ ! -z ${exgroups} ]] ; then
560 opts="${opts} -G ${exgroups:1}"
561 fi
562 else
563 egroups="(none)"
564 fi
565 einfo " - Groups: ${egroups}"
566
567 # handle extra and add the user
568 local oldsandbox=${SANDBOX_ON}
569 export SANDBOX_ON="0"
570 case ${CHOST} in
571 *-darwin*)
572 ### Make the user
573 if [[ -z $@ ]] ; then
574 dscl . create /users/${euser} uid ${euid}
575 dscl . create /users/${euser} shell ${eshell}
576 dscl . create /users/${euser} home ${ehome}
577 dscl . create /users/${euser} realname "added by portage for ${PN}"
578 ### Add the user to the groups specified
579 local oldifs=${IFS}
580 export IFS=","
581 for g in ${egroups} ; do
582 dscl . merge /groups/${g} users ${euser}
583 done
584 export IFS=${oldifs}
585 else
586 einfo "Extra options are not supported on Darwin yet"
587 einfo "Please report the ebuild along with the info below"
588 einfo "eextra: $@"
589 die "Required function missing"
590 fi
591 ;;
592 *-freebsd*|*-dragonfly*)
593 if [[ -z $@ ]] ; then
594 pw useradd ${euser} ${opts} \
595 -c "added by portage for ${PN}" \
596 die "enewuser failed"
597 else
598 einfo " - Extra: $@"
599 pw useradd ${euser} ${opts} \
600 "$@" || die "enewuser failed"
601 fi
602 ;;
603
604 *-netbsd*)
605 if [[ -z $@ ]] ; then
606 useradd ${opts} ${euser} || die "enewuser failed"
607 else
608 einfo " - Extra: $@"
609 useradd ${opts} ${euser} "$@" || die "enewuser failed"
610 fi
611 ;;
612
613 *-openbsd*)
614 if [[ -z $@ ]] ; then
615 useradd -u ${euid} -s ${eshell} \
616 -d ${ehome} -c "Added by portage for ${PN}" \
617 -g ${egroups} ${euser} || die "enewuser failed"
618 else
619 einfo " - Extra: $@"
620 useradd -u ${euid} -s ${eshell} \
621 -d ${ehome} -c "Added by portage for ${PN}" \
622 -g ${egroups} ${euser} "$@" || die "enewuser failed"
623 fi
624 ;;
625
626 *)
627 if [[ -z $@ ]] ; then
628 useradd ${opts} ${euser} \
629 -c "added by portage for ${PN}" \
630 || die "enewuser failed"
631 else
632 einfo " - Extra: $@"
633 useradd ${opts} ${euser} "$@" \
634 || die "enewuser failed"
635 fi
636 ;;
637 esac
638
639 if [[ ! -e ${ROOT}/${ehome} ]] ; then
640 einfo " - Creating ${ehome} in ${ROOT}"
641 mkdir -p "${ROOT}/${ehome}"
642 chown ${euser} "${ROOT}/${ehome}"
643 chmod 755 "${ROOT}/${ehome}"
644 fi
645
646 export SANDBOX_ON=${oldsandbox}
647}
648
649# @FUNCTION: enewgroup
650# @USAGE: <group> [gid]
651# @DESCRIPTION:
652# This function does not require you to understand how to properly add a
653# group to the system. Just give it a group name to add and enewgroup will
654# do the rest. You may specify the gid for the group or allow the group to
655# allocate the next available one.
656enewgroup() {
657 case ${EBUILD_PHASE} in
658 unpack|compile|test|install)
659 eerror "'enewgroup()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
660 eerror "Package fails at QA and at life. Please file a bug."
661 die "Bad package! enewgroup is only for use in pkg_* functions!"
662 esac
663
664 # get the group
665 local egroup="$1"; shift
666 if [ -z "${egroup}" ]
667 then
668 eerror "No group specified !"
669 die "Cannot call enewgroup without a group"
670 fi
671
672 # see if group already exists
673 if [[ -n $(egetent group "${egroup}") ]]; then
674 return 0
675 fi
676 einfo "Adding group '${egroup}' to your system ..."
677
678 # options to pass to useradd
679 local opts=
680
681 # handle gid
682 local egid="$1"; shift
683 if [ ! -z "${egid}" ]
684 then
685 if [ "${egid}" -gt 0 ]
686 then
687 if [ -z "`egetent group ${egid}`" ]
688 then
689 if [[ "${CHOST}" == *-darwin* ]]; then
690 opts="${opts} ${egid}"
691 else
692 opts="${opts} -g ${egid}"
693 fi
694 else
695 egid="next available; requested gid taken"
696 fi
697 else
698 eerror "Groupid given but is not greater than 0 !"
699 die "${egid} is not a valid GID"
700 fi
701 else
702 egid="next available"
703 fi
704 einfo " - Groupid: ${egid}"
705
706 # handle extra
707 local eextra="$@"
708 opts="${opts} ${eextra}"
709
710 # add the group
711 local oldsandbox="${SANDBOX_ON}"
712 export SANDBOX_ON="0"
713 case ${CHOST} in
714 *-darwin*)
715 if [ ! -z "${eextra}" ];
716 then
717 einfo "Extra options are not supported on Darwin/OS X yet"
718 einfo "Please report the ebuild along with the info below"
719 einfo "eextra: ${eextra}"
720 die "Required function missing"
721 fi
722
723 # If we need the next available
724 case ${egid} in
725 *[!0-9]*) # Non numeric
726 for ((egid = 101; egid <= 999; egid++)); do
727 [[ -z $(egetent group ${egid}) ]] && break
728 done
729 esac
730 dscl . create /groups/${egroup} gid ${egid}
731 dscl . create /groups/${egroup} passwd '*'
732 ;;
733
734 *-freebsd*|*-dragonfly*)
735 case ${egid} in
736 *[!0-9]*) # Non numeric
737 for ((egid = 101; egid <= 999; egid++)); do
738 [[ -z $(egetent group ${egid}) ]] && break
739 done
740 esac
741 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
742 ;;
743
744 *-netbsd*)
745 case ${egid} in
746 *[!0-9]*) # Non numeric
747 for ((egid = 101; egid <= 999; egid++)); do
748 [[ -z $(egetent group ${egid}) ]] && break
749 done
750 esac
751 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
752 ;;
753
754 *)
755 groupadd ${opts} ${egroup} || die "enewgroup failed"
756 ;;
757 esac
758 export SANDBOX_ON="${oldsandbox}"
759}
760
761# @FUNCTION: edos2unix 747# @FUNCTION: edos2unix
762# @USAGE: <file> [more files ...] 748# @USAGE: <file> [more files ...]
763# @DESCRIPTION: 749# @DESCRIPTION:
764# A handy replacement for dos2unix, recode, fixdos, etc... This allows you 750# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
765# to remove all of these text utilities from DEPEND variables because this 751# to remove all of these text utilities from DEPEND variables because this
766# is a script based solution. Just give it a list of files to convert and 752# is a script based solution. Just give it a list of files to convert and
767# they will all be changed from the DOS CRLF format to the UNIX LF format. 753# they will all be changed from the DOS CRLF format to the UNIX LF format.
768edos2unix() { 754edos2unix() {
769 echo "$@" | xargs sed -i 's/\r$//' 755 [[ $# -eq 0 ]] && return 0
756 sed -i 's/\r$//' -- "$@" || die
770} 757}
771 758
759# @FUNCTION: make_desktop_entry
760# @USAGE: make_desktop_entry(<command>, [name], [icon], [type], [fields])
761# @DESCRIPTION:
772# Make a desktop file ! 762# Make a .desktop file.
773# Great for making those icons in kde/gnome startmenu !
774# Amaze your friends ! Get the women ! Join today !
775# 763#
776# make_desktop_entry(<command>, [name], [icon], [type], [path]) 764# @CODE
777#
778# binary: what command does the app run with ? 765# binary: what command does the app run with ?
779# name: the name that will show up in the menu 766# name: the name that will show up in the menu
780# icon: give your little like a pretty little icon ... 767# icon: the icon to use in the menu entry
781# this can be relative (to /usr/share/pixmaps) or 768# this can be relative (to /usr/share/pixmaps) or
782# a full path to an icon 769# a full path to an icon
783# type: what kind of application is this ? for categories: 770# type: what kind of application is this?
771# for categories:
784# http://standards.freedesktop.org/menu-spec/latest/apa.html 772# http://standards.freedesktop.org/menu-spec/latest/apa.html
785# path: if your app needs to startup in a specific dir 773# if unset, function tries to guess from package's category
774# fields: extra fields to append to the desktop file; a printf string
775# @CODE
786make_desktop_entry() { 776make_desktop_entry() {
787 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 777 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
788 778
789 local exec=${1} 779 local exec=${1}
790 local name=${2:-${PN}} 780 local name=${2:-${PN}}
791 local icon=${3:-${PN}} 781 local icon=${3:-${PN}}
792 local type=${4} 782 local type=${4}
793 local path=${5} 783 local fields=${5}
794 784
795 if [[ -z ${type} ]] ; then 785 if [[ -z ${type} ]] ; then
796 local catmaj=${CATEGORY%%-*} 786 local catmaj=${CATEGORY%%-*}
797 local catmin=${CATEGORY##*-} 787 local catmin=${CATEGORY##*-}
798 case ${catmaj} in 788 case ${catmaj} in
799 app) 789 app)
800 case ${catmin} in 790 case ${catmin} in
801 accessibility) type=Accessibility;; 791 accessibility) type="Utility;Accessibility";;
802 admin) type=System;; 792 admin) type=System;;
803 antivirus) type=System;; 793 antivirus) type=System;;
804 arch) type=Archiving;; 794 arch) type="Utility;Archiving";;
805 backup) type=Archiving;; 795 backup) type="Utility;Archiving";;
806 cdr) type=DiscBurning;; 796 cdr) type="AudioVideo;DiscBurning";;
807 dicts) type=Dictionary;; 797 dicts) type="Office;Dictionary";;
808 doc) type=Documentation;; 798 doc) type=Documentation;;
809 editors) type=TextEditor;; 799 editors) type="Utility;TextEditor";;
810 emacs) type=TextEditor;; 800 emacs) type="Development;TextEditor";;
811 emulation) type=Emulator;; 801 emulation) type="System;Emulator";;
812 laptop) type=HardwareSettings;; 802 laptop) type="Settings;HardwareSettings";;
813 office) type=Office;; 803 office) type=Office;;
814 pda) type=PDA;; 804 pda) type="Office;PDA";;
815 vim) type=TextEditor;; 805 vim) type="Development;TextEditor";;
816 xemacs) type=TextEditor;; 806 xemacs) type="Development;TextEditor";;
817 *) type=;;
818 esac 807 esac
819 ;; 808 ;;
820 809
821 dev) 810 dev)
822 type="Development" 811 type="Development"
823 ;; 812 ;;
824 813
825 games) 814 games)
826 case ${catmin} in 815 case ${catmin} in
827 action|fps) type=ActionGame;; 816 action|fps) type=ActionGame;;
828 arcade) type=ArcadeGame;; 817 arcade) type=ArcadeGame;;
829 board) type=BoardGame;; 818 board) type=BoardGame;;
830 emulation) type=Emulator;; 819 emulation) type=Emulator;;
831 kids) type=KidsGame;; 820 kids) type=KidsGame;;
832 puzzle) type=LogicGame;; 821 puzzle) type=LogicGame;;
833 roguelike) type=RolePlaying;; 822 roguelike) type=RolePlaying;;
834 rpg) type=RolePlaying;; 823 rpg) type=RolePlaying;;
835 simulation) type=Simulation;; 824 simulation) type=Simulation;;
836 sports) type=SportsGame;; 825 sports) type=SportsGame;;
837 strategy) type=StrategyGame;; 826 strategy) type=StrategyGame;;
838 *) type=;;
839 esac 827 esac
840 type="Game;${type}" 828 type="Game;${type}"
841 ;; 829 ;;
842 830
843 gnome) 831 gnome)
852 type="Network;Email" 840 type="Network;Email"
853 ;; 841 ;;
854 842
855 media) 843 media)
856 case ${catmin} in 844 case ${catmin} in
845 gfx)
857 gfx) type=Graphics;; 846 type=Graphics
847 ;;
848 *)
849 case ${catmin} in
858 radio) type=Tuner;; 850 radio) type=Tuner;;
859 sound) type=Audio;; 851 sound) type=Audio;;
860 tv) type=TV;; 852 tv) type=TV;;
861 video) type=Video;; 853 video) type=Video;;
862 *) type=;; 854 esac
855 type="AudioVideo;${type}"
856 ;;
863 esac 857 esac
864 type="AudioVideo;${type}"
865 ;; 858 ;;
866 859
867 net) 860 net)
868 case ${catmin} in 861 case ${catmin} in
869 dialup) type=Dialup;; 862 dialup) type=Dialup;;
870 ftp) type=FileTransfer;; 863 ftp) type=FileTransfer;;
871 im) type=InstantMessaging;; 864 im) type=InstantMessaging;;
872 irc) type=IRCClient;; 865 irc) type=IRCClient;;
873 mail) type=Email;; 866 mail) type=Email;;
874 news) type=News;; 867 news) type=News;;
875 nntp) type=News;; 868 nntp) type=News;;
876 p2p) type=FileTransfer;; 869 p2p) type=FileTransfer;;
877 *) type=;; 870 voip) type=Telephony;;
878 esac 871 esac
879 type="Network;${type}" 872 type="Network;${type}"
880 ;; 873 ;;
881 874
882 sci) 875 sci)
883 case ${catmin} in 876 case ${catmin} in
884 astro*) type=Astronomy;; 877 astro*) type=Astronomy;;
885 bio*) type=Biology;; 878 bio*) type=Biology;;
886 calc*) type=Calculator;; 879 calc*) type=Calculator;;
887 chem*) type=Chemistry;; 880 chem*) type=Chemistry;;
888 elec*) type=Electronics;; 881 elec*) type=Electronics;;
889 geo*) type=Geology;; 882 geo*) type=Geology;;
890 math*) type=Math;; 883 math*) type=Math;;
891 physics) type=Physics;; 884 physics) type=Physics;;
892 visual*) type=DataVisualization;; 885 visual*) type=DataVisualization;;
893 *) type=;;
894 esac 886 esac
895 type="Science;${type}" 887 type="Education;Science;${type}"
896 ;; 888 ;;
897 889
898 sys) 890 sys)
899 type="System" 891 type="System"
900 ;; 892 ;;
901 893
902 www) 894 www)
903 case ${catmin} in 895 case ${catmin} in
904 client) type=WebBrowser;; 896 client) type=WebBrowser;;
905 *) type=;;
906 esac 897 esac
907 type="Network" 898 type="Network;${type}"
908 ;; 899 ;;
909 900
910 *) 901 *)
911 type= 902 type=
912 ;; 903 ;;
918 local desktop_name="${PN}-${SLOT}" 909 local desktop_name="${PN}-${SLOT}"
919 fi 910 fi
920 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop" 911 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
921 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop 912 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
922 913
914 # Don't append another ";" when a valid category value is provided.
915 type=${type%;}${type:+;}
916
917 eshopts_push -s extglob
918 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
919 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
920 ewarn "allowed in .desktop files if the value is not an absolute path."
921 icon=${icon%.@(xpm|png|svg)}
922 fi
923 eshopts_pop
924
923 cat <<-EOF > "${desktop}" 925 cat <<-EOF > "${desktop}"
924 [Desktop Entry] 926 [Desktop Entry]
925 Version=1.0
926 Name=${name} 927 Name=${name}
927 Type=Application 928 Type=Application
928 Comment=${DESCRIPTION} 929 Comment=${DESCRIPTION}
929 Exec=${exec} 930 Exec=${exec}
930 TryExec=${exec%% *} 931 TryExec=${exec%% *}
931 Icon=${icon} 932 Icon=${icon}
932 Categories=${type}; 933 Categories=${type}
933 EOF 934 EOF
934 935
935 [[ ${path} ]] && echo "Path=${path}" >> "${desktop}" 936 if [[ ${fields:-=} != *=* ]] ; then
937 # 5th arg used to be value to Path=
938 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
939 fields="Path=${fields}"
940 fi
941 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
936 942
937 ( 943 (
938 # wrap the env here so that the 'insinto' call 944 # wrap the env here so that the 'insinto' call
939 # doesn't corrupt the env of the caller 945 # doesn't corrupt the env of the caller
940 insinto /usr/share/applications 946 insinto /usr/share/applications
941 doins "${desktop}" 947 doins "${desktop}"
942 ) 948 ) || die "installing desktop file failed"
949}
950
951# @FUNCTION: _eutils_eprefix_init
952# @INTERNAL
953# @DESCRIPTION:
954# Initialized prefix variables for EAPI<3.
955_eutils_eprefix_init() {
956 has "${EAPI:-0}" 0 1 2 && : ${ED:=${D}} ${EPREFIX:=} ${EROOT:=${ROOT}}
943} 957}
944 958
945# @FUNCTION: validate_desktop_entries 959# @FUNCTION: validate_desktop_entries
946# @USAGE: [directories] 960# @USAGE: [directories]
947# @MAINTAINER: 961# @MAINTAINER:
948# Carsten Lohrke <carlo@gentoo.org> 962# Carsten Lohrke <carlo@gentoo.org>
949# @DESCRIPTION: 963# @DESCRIPTION:
950# Validate desktop entries using desktop-file-utils 964# Validate desktop entries using desktop-file-utils
951validate_desktop_entries() { 965validate_desktop_entries() {
966 _eutils_eprefix_init
952 if [[ -x /usr/bin/desktop-file-validate ]] ; then 967 if [[ -x "${EPREFIX}"/usr/bin/desktop-file-validate ]] ; then
953 einfo "Checking desktop entry validity" 968 einfo "Checking desktop entry validity"
954 local directories="" 969 local directories=""
955 for d in /usr/share/applications $@ ; do 970 for d in /usr/share/applications $@ ; do
956 [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}" 971 [[ -d ${ED}${d} ]] && directories="${directories} ${ED}${d}"
957 done 972 done
958 if [[ -n ${directories} ]] ; then 973 if [[ -n ${directories} ]] ; then
959 for FILE in $(find ${directories} -name "*\.desktop" \ 974 for FILE in $(find ${directories} -name "*\.desktop" \
960 -not -path '*.hidden*' | sort -u 2>/dev/null) 975 -not -path '*.hidden*' | sort -u 2>/dev/null)
961 do 976 do
962 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \ 977 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
963 sed -e "s|error: ||" -e "s|${FILE}:|--|g" ) 978 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
964 [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:} 979 [[ -n $temp ]] && elog ${temp/--/${FILE/${ED}/}:}
965 done 980 done
966 fi 981 fi
967 echo "" 982 echo ""
968 else 983 else
969 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo." 984 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
1042 insinto /usr/share/applications 1057 insinto /usr/share/applications
1043 newins "$@" 1058 newins "$@"
1044 ) 1059 )
1045} 1060}
1046 1061
1047# @FUNCTION: doicon 1062# @FUNCTION: _iconins
1048# @USAGE: <list of icons> 1063# @INTERNAL
1049# @DESCRIPTION: 1064# @DESCRIPTION:
1050# Install the list of icons into the icon directory (/usr/share/pixmaps). 1065# function for use in doicon and newicon
1051# This is useful in conjunction with creating desktop/menu files. 1066_iconins() {
1052doicon() {
1053 ( 1067 (
1054 # wrap the env here so that the 'insinto' call 1068 # wrap the env here so that the 'insinto' call
1055 # doesn't corrupt the env of the caller 1069 # doesn't corrupt the env of the caller
1056 local i j ret 1070 local funcname=$1; shift
1057 insinto /usr/share/pixmaps 1071 local size dir
1058 for i in "$@" ; do 1072 local context=apps
1059 if [[ -f ${i} ]] ; then 1073 local theme=hicolor
1060 doins "${i}" 1074
1061 ((ret+=$?)) 1075 while [[ $# -gt 0 ]] ; do
1062 elif [[ -d ${i} ]] ; then 1076 case $1 in
1063 for j in "${i}"/*.png ; do 1077 -s|--size)
1064 doins "${j}" 1078 if [[ ${2%%x*}x${2%%x*} == "$2" ]] ; then
1065 ((ret+=$?)) 1079 size=${2%%x*}
1066 done
1067 else 1080 else
1068 ((++ret)) 1081 size=${2}
1069 fi 1082 fi
1070 done
1071 exit ${ret}
1072 )
1073}
1074
1075# @FUNCTION: newicon
1076# @USAGE: <icon> <newname>
1077# @DESCRIPTION:
1078# Like all other new* functions, install the specified icon as newname.
1079newicon() {
1080 (
1081 # wrap the env here so that the 'insinto' call
1082 # doesn't corrupt the env of the caller
1083 insinto /usr/share/pixmaps
1084 newins "$@"
1085 )
1086}
1087
1088# for internal use only (unpack_pdv and unpack_makeself)
1089find_unpackable_file() {
1090 local src=$1
1091 if [[ -z ${src} ]] ; then
1092 src=${DISTDIR}/${A}
1093 else
1094 if [[ -e ${DISTDIR}/${src} ]] ; then
1095 src=${DISTDIR}/${src}
1096 elif [[ -e ${PWD}/${src} ]] ; then
1097 src=${PWD}/${src}
1098 elif [[ -e ${src} ]] ; then
1099 src=${src}
1100 fi
1101 fi
1102 [[ ! -e ${src} ]] && return 1
1103 echo "${src}"
1104}
1105
1106# @FUNCTION: unpack_pdv
1107# @USAGE: <file to unpack> <size of off_t>
1108# @DESCRIPTION:
1109# Unpack those pesky pdv generated files ...
1110# They're self-unpacking programs with the binary package stuffed in
1111# the middle of the archive. Valve seems to use it a lot ... too bad
1112# it seems to like to segfault a lot :(. So lets take it apart ourselves.
1113#
1114# You have to specify the off_t size ... I have no idea how to extract that
1115# information out of the binary executable myself. Basically you pass in
1116# the size of the off_t type (in bytes) on the machine that built the pdv
1117# archive.
1118#
1119# One way to determine this is by running the following commands:
1120#
1121# @CODE
1122# strings <pdv archive> | grep lseek
1123# strace -elseek <pdv archive>
1124# @CODE
1125#
1126# Basically look for the first lseek command (we do the strings/grep because
1127# sometimes the function call is _llseek or something) and steal the 2nd
1128# parameter. Here is an example:
1129#
1130# @CODE
1131# vapier@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
1132# lseek
1133# vapier@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
1134# lseek(3, -4, SEEK_END) = 2981250
1135# @CODE
1136#
1137# Thus we would pass in the value of '4' as the second parameter.
1138unpack_pdv() {
1139 local src=$(find_unpackable_file "$1")
1140 local sizeoff_t=$2
1141
1142 [[ -z ${src} ]] && die "Could not locate source for '$1'"
1143 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :("
1144
1145 local shrtsrc=$(basename "${src}")
1146 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1147 local metaskip=$(tail -c ${sizeoff_t} "${src}" | hexdump -e \"%i\")
1148 local tailskip=$(tail -c $((${sizeoff_t}*2)) "${src}" | head -c ${sizeoff_t} | hexdump -e \"%i\")
1149
1150 # grab metadata for debug reasons
1151 local metafile=$(emktemp)
1152 tail -c +$((${metaskip}+1)) "${src}" > "${metafile}"
1153
1154 # rip out the final file name from the metadata
1155 local datafile=$(tail -c +$((${metaskip}+1)) "${src}" | strings | head -n 1)
1156 datafile=$(basename "${datafile}")
1157
1158 # now lets uncompress/untar the file if need be
1159 local tmpfile=$(emktemp)
1160 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile}
1161
1162 local iscompressed=$(file -b "${tmpfile}")
1163 if [[ ${iscompressed:0:8} == "compress" ]] ; then
1164 iscompressed=1
1165 mv ${tmpfile}{,.Z}
1166 gunzip ${tmpfile}
1167 else
1168 iscompressed=0
1169 fi
1170 local istar=$(file -b "${tmpfile}")
1171 if [[ ${istar:0:9} == "POSIX tar" ]] ; then
1172 istar=1
1173 else
1174 istar=0
1175 fi
1176
1177 #for some reason gzip dies with this ... dd cant provide buffer fast enough ?
1178 #dd if=${src} ibs=${metaskip} count=1 \
1179 # | dd ibs=${tailskip} skip=1 \
1180 # | gzip -dc \
1181 # > ${datafile}
1182 if [ ${iscompressed} -eq 1 ] ; then
1183 if [ ${istar} -eq 1 ] ; then
1184 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1185 | head -c $((${metaskip}-${tailskip})) \
1186 | tar -xzf -
1187 else
1188 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1189 | head -c $((${metaskip}-${tailskip})) \
1190 | gzip -dc \
1191 > ${datafile}
1192 fi
1193 else
1194 if [ ${istar} -eq 1 ] ; then
1195 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1196 | head -c $((${metaskip}-${tailskip})) \
1197 | tar --no-same-owner -xf -
1198 else
1199 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1200 | head -c $((${metaskip}-${tailskip})) \
1201 > ${datafile}
1202 fi
1203 fi
1204 true
1205 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1206 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1207}
1208
1209# @FUNCTION: unpack_makeself
1210# @USAGE: [file to unpack] [offset] [tail|dd]
1211# @DESCRIPTION:
1212# Unpack those pesky makeself generated files ...
1213# They're shell scripts with the binary package tagged onto
1214# the end of the archive. Loki utilized the format as does
1215# many other game companies.
1216#
1217# If the file is not specified, then ${A} is used. If the
1218# offset is not specified then we will attempt to extract
1219# the proper offset from the script itself.
1220unpack_makeself() {
1221 local src_input=${1:-${A}}
1222 local src=$(find_unpackable_file "${src_input}")
1223 local skip=$2
1224 local exe=$3
1225
1226 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1227
1228 local shrtsrc=$(basename "${src}")
1229 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1230 if [[ -z ${skip} ]] ; then
1231 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}')
1232 local skip=0
1233 exe=tail
1234 case ${ver} in 1083 case ${size} in
1235 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 1084 16|22|24|32|36|48|64|72|96|128|192|256)
1236 skip=$(grep -a ^skip= "${src}" | cut -d= -f2) 1085 size=${size}x${size};;
1237 ;; 1086 scalable)
1238 2.0|2.0.1)
1239 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1240 ;;
1241 2.1.1)
1242 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1243 let skip="skip + 1"
1244 ;;
1245 2.1.2)
1246 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1247 let skip="skip + 1"
1248 ;;
1249 2.1.3)
1250 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1251 let skip="skip + 1"
1252 ;;
1253 2.1.4|2.1.5)
1254 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1255 skip=$(head -n ${skip} "${src}" | wc -c)
1256 exe="dd"
1257 ;; 1087 ;;
1258 *) 1088 *)
1259 eerror "I'm sorry, but I was unable to support the Makeself file." 1089 eerror "${size} is an unsupported icon size!"
1260 eerror "The version I detected was '${ver}'." 1090 exit 1;;
1261 eerror "Please file a bug about the file ${shrtsrc} at"
1262 eerror "http://bugs.gentoo.org/ so that support can be added."
1263 die "makeself version '${ver}' not supported"
1264 ;;
1265 esac 1091 esac
1266 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset" 1092 shift 2;;
1267 fi 1093 -t|--theme)
1268 case ${exe} in 1094 theme=${2}
1269 tail) exe="tail -n +${skip} '${src}'";; 1095 shift 2;;
1270 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";; 1096 -c|--context)
1271 *) die "makeself cant handle exe '${exe}'" 1097 context=${2}
1272 esac 1098 shift 2;;
1273
1274 # lets grab the first few bytes of the file to figure out what kind of archive it is
1275 local tmpfile=$(emktemp)
1276 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1277 local filetype=$(file -b "${tmpfile}")
1278 case ${filetype} in
1279 *tar\ archive*)
1280 eval ${exe} | tar --no-same-owner -xf -
1281 ;;
1282 bzip2*)
1283 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf -
1284 ;;
1285 gzip*)
1286 eval ${exe} | tar --no-same-owner -xzf -
1287 ;;
1288 compress*)
1289 eval ${exe} | gunzip | tar --no-same-owner -xf -
1290 ;;
1291 *) 1099 *)
1292 eerror "Unknown filetype \"${filetype}\" ?"
1293 false
1294 ;;
1295 esac
1296 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1297}
1298
1299# @FUNCTION: check_license
1300# @USAGE: [license]
1301# @DESCRIPTION:
1302# Display a license for user to accept. If no license is
1303# specified, then ${LICENSE} is used.
1304check_license() {
1305 local lic=$1
1306 if [ -z "${lic}" ] ; then
1307 lic="${PORTDIR}/licenses/${LICENSE}"
1308 else
1309 if [ -e "${PORTDIR}/licenses/${lic}" ] ; then
1310 lic="${PORTDIR}/licenses/${lic}"
1311 elif [ -e "${PWD}/${lic}" ] ; then
1312 lic="${PWD}/${lic}"
1313 elif [ -e "${lic}" ] ; then
1314 lic="${lic}"
1315 fi
1316 fi
1317 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1318 local l="`basename ${lic}`"
1319
1320 # here is where we check for the licenses the user already
1321 # accepted ... if we don't find a match, we make the user accept
1322 local shopts=$-
1323 local alic
1324 set -o noglob #so that bash doesn't expand "*"
1325 for alic in ${ACCEPT_LICENSE} ; do
1326 if [[ ${alic} == ${l} ]]; then
1327 set +o noglob; set -${shopts} #reset old shell opts
1328 return 0
1329 fi
1330 done
1331 set +o noglob; set -$shopts #reset old shell opts
1332
1333 local licmsg=$(emktemp)
1334 cat <<-EOF > ${licmsg}
1335 **********************************************************
1336 The following license outlines the terms of use of this
1337 package. You MUST accept this license for installation to
1338 continue. When you are done viewing, hit 'q'. If you
1339 CTRL+C out of this, the install will not run!
1340 **********************************************************
1341
1342 EOF
1343 cat ${lic} >> ${licmsg}
1344 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1345 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1346 read alic
1347 case ${alic} in
1348 yes|Yes|y|Y)
1349 return 0
1350 ;;
1351 *)
1352 echo;echo;echo
1353 eerror "You MUST accept the license to continue! Exiting!"
1354 die "Failed to accept license"
1355 ;;
1356 esac
1357}
1358
1359# @FUNCTION: cdrom_get_cds
1360# @USAGE: <file on cd1> [file on cd2] [file on cd3] [...]
1361# @DESCRIPTION:
1362# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
1363# the whole 'non-interactive' policy, but damnit I want CD support !
1364#
1365# With these cdrom functions we handle all the user interaction and
1366# standardize everything. All you have to do is call cdrom_get_cds()
1367# and when the function returns, you can assume that the cd has been
1368# found at CDROM_ROOT.
1369#
1370# The function will attempt to locate a cd based upon a file that is on
1371# the cd. The more files you give this function, the more cds
1372# the cdrom functions will handle.
1373#
1374# Normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1375# etc... If you want to give the cds better names, then just export
1376# the appropriate CDROM_NAME variable before calling cdrom_get_cds().
1377# Use CDROM_NAME for one cd, or CDROM_NAME_# for multiple cds. You can
1378# also use the CDROM_NAME_SET bash array.
1379#
1380# For those multi cd ebuilds, see the cdrom_load_next_cd() function.
1381cdrom_get_cds() {
1382 # first we figure out how many cds we're dealing with by
1383 # the # of files they gave us
1384 local cdcnt=0
1385 local f=
1386 for f in "$@" ; do
1387 ((++cdcnt))
1388 export CDROM_CHECK_${cdcnt}="$f"
1389 done
1390 export CDROM_TOTAL_CDS=${cdcnt}
1391 export CDROM_CURRENT_CD=1
1392
1393 # now we see if the user gave use CD_ROOT ...
1394 # if they did, let's just believe them that it's correct
1395 if [[ -n ${CD_ROOT}${CD_ROOT_1} ]] ; then
1396 local var=
1397 cdcnt=0
1398 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1399 ((++cdcnt))
1400 var="CD_ROOT_${cdcnt}"
1401 [[ -z ${!var} ]] && var="CD_ROOT"
1402 if [[ -z ${!var} ]] ; then 1100 if [[ -z ${size} ]] ; then
1403 eerror "You must either use just the CD_ROOT" 1101 insinto /usr/share/pixmaps
1404 eerror "or specify ALL the CD_ROOT_X variables." 1102 else
1405 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables." 1103 insinto /usr/share/icons/${theme}/${size}/${context}
1406 die "could not locate CD_ROOT_${cdcnt}"
1407 fi 1104 fi
1408 done
1409 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1410 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1411 export CDROM_SET=-1
1412 for f in ${CDROM_CHECK_1//:/ } ; do
1413 ((++CDROM_SET))
1414 [[ -e ${CD_ROOT}/${f} ]] && break
1415 done
1416 export CDROM_MATCH=${f}
1417 return
1418 fi
1419 1105
1420 # User didn't help us out so lets make sure they know they can 1106 if [[ ${funcname} == doicon ]] ; then
1421 # simplify the whole process ...
1422 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1423 einfo "This ebuild will need the ${CDROM_NAME:-cdrom for ${PN}}"
1424 echo
1425 einfo "If you do not have the CD, but have the data files"
1426 einfo "mounted somewhere on your filesystem, just export"
1427 einfo "the variable CD_ROOT so that it points to the"
1428 einfo "directory containing the files."
1429 echo
1430 einfo "For example:"
1431 einfo "export CD_ROOT=/mnt/cdrom"
1432 echo
1433 else
1434 if [[ -n ${CDROM_NAME_SET} ]] ; then
1435 # Translate the CDROM_NAME_SET array into CDROM_NAME_#
1436 cdcnt=0
1437 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1438 ((++cdcnt))
1439 export CDROM_NAME_${cdcnt}="${CDROM_NAME_SET[$((${cdcnt}-1))]}"
1440 done
1441 fi
1442
1443 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
1444 cdcnt=0
1445 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1446 ((++cdcnt))
1447 var="CDROM_NAME_${cdcnt}"
1448 [[ ! -z ${!var} ]] && einfo " CD ${cdcnt}: ${!var}"
1449 done
1450 echo
1451 einfo "If you do not have the CDs, but have the data files"
1452 einfo "mounted somewhere on your filesystem, just export"
1453 einfo "the following variables so they point to the right place:"
1454 einfon ""
1455 cdcnt=0
1456 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1457 ((++cdcnt))
1458 echo -n " CD_ROOT_${cdcnt}"
1459 done
1460 echo
1461 einfo "Or, if you have all the files in the same place, or"
1462 einfo "you only have one cdrom, you can export CD_ROOT"
1463 einfo "and that place will be used as the same data source"
1464 einfo "for all the CDs."
1465 echo
1466 einfo "For example:"
1467 einfo "export CD_ROOT_1=/mnt/cdrom"
1468 echo
1469 fi
1470
1471 export CDROM_SET=""
1472 export CDROM_CURRENT_CD=0
1473 cdrom_load_next_cd
1474}
1475
1476# @FUNCTION: cdrom_load_next_cd
1477# @DESCRIPTION:
1478# Some packages are so big they come on multiple CDs. When you're done reading
1479# files off a CD and want access to the next one, just call this function.
1480# Again, all the messy details of user interaction are taken care of for you.
1481# Once this returns, just read the variable CDROM_ROOT for the location of the
1482# mounted CD. Note that you can only go forward in the CD list, so make sure
1483# you only call this function when you're done using the current CD.
1484cdrom_load_next_cd() {
1485 local var
1486 ((++CDROM_CURRENT_CD))
1487
1488 unset CDROM_ROOT
1489 var=CD_ROOT_${CDROM_CURRENT_CD}
1490 [[ -z ${!var} ]] && var="CD_ROOT"
1491 if [[ -z ${!var} ]] ; then 1107 if [[ -f $1 ]] ; then
1492 var="CDROM_CHECK_${CDROM_CURRENT_CD}" 1108 doins "${1}"
1493 _cdrom_locate_file_on_cd ${!var} 1109 elif [[ -d $1 ]] ; then
1494 else 1110 shopt -s nullglob
1495 export CDROM_ROOT=${!var} 1111 doins "${1}"/*.{png,svg}
1496 fi 1112 shopt -u nullglob
1497
1498 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1499}
1500
1501# this is used internally by the cdrom_get_cds() and cdrom_load_next_cd()
1502# functions. this should *never* be called from an ebuild.
1503# all it does is try to locate a give file on a cd ... if the cd isn't
1504# found, then a message asking for the user to insert the cdrom will be
1505# displayed and we'll hang out here until:
1506# (1) the file is found on a mounted cdrom
1507# (2) the user hits CTRL+C
1508_cdrom_locate_file_on_cd() {
1509 local mline=""
1510 local showedmsg=0 showjolietmsg=0
1511
1512 while [[ -z ${CDROM_ROOT} ]] ; do
1513 local i=0
1514 local -a cdset=(${*//:/ })
1515 if [[ -n ${CDROM_SET} ]] ; then
1516 cdset=(${cdset[${CDROM_SET}]})
1517 fi
1518
1519 while [[ -n ${cdset[${i}]} ]] ; do
1520 local dir=$(dirname ${cdset[${i}]})
1521 local file=$(basename ${cdset[${i}]})
1522
1523 local point= node= fs= foo=
1524 while read point node fs foo ; do
1525 [[ " cd9660 iso9660 udf " != *" ${fs} "* ]] && \
1526 ! [[ ${fs} == "subfs" && ",${opts}," == *",fs=cdfss,"* ]] \
1527 && continue
1528 point=${point//\040/ }
1529 [[ ! -d ${point}/${dir} ]] && continue
1530 [[ -z $(find "${point}/${dir}" -maxdepth 1 -iname "${file}") ]] && continue
1531 export CDROM_ROOT=${point}
1532 export CDROM_SET=${i}
1533 export CDROM_MATCH=${cdset[${i}]}
1534 return
1535 done <<< "$(get_mounts)"
1536
1537 ((++i))
1538 done
1539
1540 echo
1541 if [[ ${showedmsg} -eq 0 ]] ; then
1542 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1543 if [[ -z ${CDROM_NAME} ]] ; then
1544 einfo "Please insert+mount the cdrom for ${PN} now !"
1545 else 1113 else
1546 einfo "Please insert+mount the ${CDROM_NAME} cdrom now !" 1114 eerror "${1} is not a valid file/directory!"
1115 exit 1
1547 fi 1116 fi
1548 else 1117 else
1549 if [[ -z ${CDROM_NAME_1} ]] ; then 1118 break
1550 einfo "Please insert+mount cd #${CDROM_CURRENT_CD} for ${PN} now !"
1551 else
1552 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1553 einfo "Please insert+mount the ${!var} cdrom now !"
1554 fi
1555 fi 1119 fi
1556 showedmsg=1 1120 shift 1;;
1557 fi 1121 esac
1558 einfo "Press return to scan for the cd again"
1559 einfo "or hit CTRL+C to abort the emerge."
1560 echo
1561 if [[ ${showjolietmsg} -eq 0 ]] ; then
1562 showjolietmsg=1
1563 else
1564 ewarn "If you are having trouble with the detection"
1565 ewarn "of your CD, it is possible that you do not have"
1566 ewarn "Joliet support enabled in your kernel. Please"
1567 ewarn "check that CONFIG_JOLIET is enabled in your kernel."
1568 ebeep 5
1569 fi
1570 read || die "something is screwed with your system"
1571 done 1122 done
1123 if [[ ${funcname} == newicon ]] ; then
1124 newins "$@"
1125 fi
1126 ) || die
1127}
1128
1129# @FUNCTION: doicon
1130# @USAGE: [options] <icons>
1131# @DESCRIPTION:
1132# Install icon into the icon directory /usr/share/icons or into
1133# /usr/share/pixmaps if "--size" is not set.
1134# This is useful in conjunction with creating desktop/menu files.
1135#
1136# @CODE
1137# options:
1138# -s, --size
1139# !!! must specify to install into /usr/share/icons/... !!!
1140# size of the icon, like 48 or 48x48
1141# supported icon sizes are:
1142# 16 22 24 32 36 48 64 72 96 128 192 256 scalable
1143# -c, --context
1144# defaults to "apps"
1145# -t, --theme
1146# defaults to "hicolor"
1147#
1148# icons: list of icons
1149#
1150# example 1: doicon foobar.png fuqbar.svg suckbar.png
1151# results in: insinto /usr/share/pixmaps
1152# doins foobar.png fuqbar.svg suckbar.png
1153#
1154# example 2: doicon -s 48 foobar.png fuqbar.png blobbar.png
1155# results in: insinto /usr/share/icons/hicolor/48x48/apps
1156# doins foobar.png fuqbar.png blobbar.png
1157# @CODE
1158doicon() {
1159 _iconins ${FUNCNAME} "$@"
1160}
1161
1162# @FUNCTION: newicon
1163# @USAGE: [options] <icon> <newname>
1164# @DESCRIPTION:
1165# Like doicon, install the specified icon as newname.
1166#
1167# @CODE
1168# example 1: newicon foobar.png NEWNAME.png
1169# results in: insinto /usr/share/pixmaps
1170# newins foobar.png NEWNAME.png
1171#
1172# example 2: newicon -s 48 foobar.png NEWNAME.png
1173# results in: insinto /usr/share/icons/hicolor/48x48/apps
1174# newins foobar.png NEWNAME.png
1175# @CODE
1176newicon() {
1177 _iconins ${FUNCNAME} "$@"
1572} 1178}
1573 1179
1574# @FUNCTION: strip-linguas 1180# @FUNCTION: strip-linguas
1575# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>] 1181# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
1576# @DESCRIPTION: 1182# @DESCRIPTION:
1593 else 1199 else
1594 newls="" 1200 newls=""
1595 fi 1201 fi
1596 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do 1202 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1597 if [[ ${op} == "-i" ]] ; then 1203 if [[ ${op} == "-i" ]] ; then
1598 hasq ${f} ${ls} && newls="${newls} ${f}" 1204 has ${f} ${ls} && newls="${newls} ${f}"
1599 else 1205 else
1600 hasq ${f} ${ls} || newls="${newls} ${f}" 1206 has ${f} ${ls} || newls="${newls} ${f}"
1601 fi 1207 fi
1602 done 1208 done
1603 ls=${newls} 1209 ls=${newls}
1604 done 1210 done
1605 else 1211 else
1607 fi 1213 fi
1608 1214
1609 nols="" 1215 nols=""
1610 newls="" 1216 newls=""
1611 for f in ${LINGUAS} ; do 1217 for f in ${LINGUAS} ; do
1612 if hasq ${f} ${ls} ; then 1218 if has ${f} ${ls} ; then
1613 newls="${newls} ${f}" 1219 newls="${newls} ${f}"
1614 else 1220 else
1615 nols="${nols} ${f}" 1221 nols="${nols} ${f}"
1616 fi 1222 fi
1617 done 1223 done
1618 [[ -n ${nols} ]] \ 1224 [[ -n ${nols} ]] \
1619 && ewarn "Sorry, but ${PN} does not support the LINGUAs:" ${nols} 1225 && einfo "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1620 export LINGUAS=${newls:1} 1226 export LINGUAS=${newls:1}
1621} 1227}
1622 1228
1623# @FUNCTION: preserve_old_lib 1229# @FUNCTION: preserve_old_lib
1624# @USAGE: <libs to preserve> [more libs] 1230# @USAGE: <libs to preserve> [more libs]
1628# would break packages that link against it. Most people get around this 1234# would break packages that link against it. Most people get around this
1629# by using the portage SLOT mechanism, but that is not always a relevant 1235# by using the portage SLOT mechanism, but that is not always a relevant
1630# solution, so instead you can call this from pkg_preinst. See also the 1236# solution, so instead you can call this from pkg_preinst. See also the
1631# preserve_old_lib_notify function. 1237# preserve_old_lib_notify function.
1632preserve_old_lib() { 1238preserve_old_lib() {
1239 _eutils_eprefix_init
1633 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then 1240 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1634 eerror "preserve_old_lib() must be called from pkg_preinst() only" 1241 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1635 die "Invalid preserve_old_lib() usage" 1242 die "Invalid preserve_old_lib() usage"
1636 fi 1243 fi
1637 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]" 1244 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1639 # let portage worry about it 1246 # let portage worry about it
1640 has preserve-libs ${FEATURES} && return 0 1247 has preserve-libs ${FEATURES} && return 0
1641 1248
1642 local lib dir 1249 local lib dir
1643 for lib in "$@" ; do 1250 for lib in "$@" ; do
1644 [[ -e ${ROOT}/${lib} ]] || continue 1251 [[ -e ${EROOT}/${lib} ]] || continue
1645 dir=${lib%/*} 1252 dir=${lib%/*}
1646 dodir ${dir} || die "dodir ${dir} failed" 1253 dodir ${dir} || die "dodir ${dir} failed"
1647 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed" 1254 cp "${EROOT}"/${lib} "${ED}"/${lib} || die "cp ${lib} failed"
1648 touch "${D}"/${lib} 1255 touch "${ED}"/${lib}
1649 done 1256 done
1650} 1257}
1651 1258
1652# @FUNCTION: preserve_old_lib_notify 1259# @FUNCTION: preserve_old_lib_notify
1653# @USAGE: <libs to notify> [more libs] 1260# @USAGE: <libs to notify> [more libs]
1660 fi 1267 fi
1661 1268
1662 # let portage worry about it 1269 # let portage worry about it
1663 has preserve-libs ${FEATURES} && return 0 1270 has preserve-libs ${FEATURES} && return 0
1664 1271
1272 _eutils_eprefix_init
1273
1665 local lib notice=0 1274 local lib notice=0
1666 for lib in "$@" ; do 1275 for lib in "$@" ; do
1667 [[ -e ${ROOT}/${lib} ]] || continue 1276 [[ -e ${EROOT}/${lib} ]] || continue
1668 if [[ ${notice} -eq 0 ]] ; then 1277 if [[ ${notice} -eq 0 ]] ; then
1669 notice=1 1278 notice=1
1670 ewarn "Old versions of installed libraries were detected on your system." 1279 ewarn "Old versions of installed libraries were detected on your system."
1671 ewarn "In order to avoid breaking packages that depend on these old libs," 1280 ewarn "In order to avoid breaking packages that depend on these old libs,"
1672 ewarn "the libraries are not being removed. You need to run revdep-rebuild" 1281 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1673 ewarn "in order to remove these old dependencies. If you do not have this" 1282 ewarn "in order to remove these old dependencies. If you do not have this"
1674 ewarn "helper program, simply emerge the 'gentoolkit' package." 1283 ewarn "helper program, simply emerge the 'gentoolkit' package."
1675 ewarn 1284 ewarn
1676 fi 1285 fi
1677 ewarn " # revdep-rebuild --library ${lib##*/}" 1286 ewarn " # revdep-rebuild --library '${lib}' && rm '${lib}'"
1678 done 1287 done
1679 if [[ ${notice} -eq 1 ]] ; then
1680 ewarn
1681 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1682 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1683 for lib in "$@" ; do
1684 ewarn " # rm '${lib}'"
1685 done
1686 fi
1687} 1288}
1688 1289
1689# @FUNCTION: built_with_use 1290# @FUNCTION: built_with_use
1690# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags> 1291# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1691# @DESCRIPTION: 1292# @DESCRIPTION:
1293#
1294# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1295#
1692# A temporary hack until portage properly supports DEPENDing on USE 1296# A temporary hack until portage properly supports DEPENDing on USE
1693# flags being enabled in packages. This will check to see if the specified 1297# flags being enabled in packages. This will check to see if the specified
1694# DEPEND atom was built with the specified list of USE flags. The 1298# DEPEND atom was built with the specified list of USE flags. The
1695# --missing option controls the behavior if called on a package that does 1299# --missing option controls the behavior if called on a package that does
1696# not actually support the defined USE flags (aka listed in IUSE). 1300# not actually support the defined USE flags (aka listed in IUSE).
1703# in IUSE like normal USE flags. 1307# in IUSE like normal USE flags.
1704# 1308#
1705# Remember that this function isn't terribly intelligent so order of optional 1309# Remember that this function isn't terribly intelligent so order of optional
1706# flags matter. 1310# flags matter.
1707built_with_use() { 1311built_with_use() {
1312 _eutils_eprefix_init
1708 local hidden="no" 1313 local hidden="no"
1709 if [[ $1 == "--hidden" ]] ; then 1314 if [[ $1 == "--hidden" ]] ; then
1710 hidden="yes" 1315 hidden="yes"
1711 shift 1316 shift
1712 fi 1317 fi
1726 1331
1727 local PKG=$(best_version $1) 1332 local PKG=$(best_version $1)
1728 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package" 1333 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
1729 shift 1334 shift
1730 1335
1731 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE 1336 local USEFILE=${EROOT}/var/db/pkg/${PKG}/USE
1732 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE 1337 local IUSEFILE=${EROOT}/var/db/pkg/${PKG}/IUSE
1733 1338
1734 # if the IUSE file doesn't exist, the read will error out, we need to handle 1339 # if the IUSE file doesn't exist, the read will error out, we need to handle
1735 # this gracefully 1340 # this gracefully
1736 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then 1341 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
1737 case ${missing_action} in 1342 case ${missing_action} in
1783# http://bugs.gentoo.org/73450 1388# http://bugs.gentoo.org/73450
1784epunt_cxx() { 1389epunt_cxx() {
1785 local dir=$1 1390 local dir=$1
1786 [[ -z ${dir} ]] && dir=${S} 1391 [[ -z ${dir} ]] && dir=${S}
1787 ebegin "Removing useless C++ checks" 1392 ebegin "Removing useless C++ checks"
1788 local f 1393 local f p any_found
1789 find "${dir}" -name configure | while read f ; do 1394 while IFS= read -r -d '' f; do
1790 patch --no-backup-if-mismatch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null 1395 for p in "${PORTDIR}"/eclass/ELT-patches/nocxx/*.patch ; do
1396 if patch --no-backup-if-mismatch -p1 "${f}" "${p}" >/dev/null ; then
1397 any_found=1
1398 break
1399 fi
1791 done 1400 done
1401 done < <(find "${dir}" -name configure -print0)
1402
1403 if [[ -z ${any_found} ]]; then
1404 eqawarn "epunt_cxx called unnecessarily (no C++ checks to punt)."
1405 fi
1792 eend 0 1406 eend 0
1793} 1407}
1794 1408
1795# @FUNCTION: make_wrapper 1409# @FUNCTION: make_wrapper
1796# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath] 1410# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1798# Create a shell wrapper script named wrapper in installpath 1412# Create a shell wrapper script named wrapper in installpath
1799# (defaults to the bindir) to execute target (default of wrapper) by 1413# (defaults to the bindir) to execute target (default of wrapper) by
1800# first optionally setting LD_LIBRARY_PATH to the colon-delimited 1414# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1801# libpaths followed by optionally changing directory to chdir. 1415# libpaths followed by optionally changing directory to chdir.
1802make_wrapper() { 1416make_wrapper() {
1417 _eutils_eprefix_init
1803 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5 1418 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1804 local tmpwrapper=$(emktemp) 1419 local tmpwrapper=$(emktemp)
1420
1421 (
1422 echo '#!/bin/sh'
1423 [[ -n ${chdir} ]] && printf 'cd "%s"\n' "${EPREFIX}${chdir}"
1424 if [[ -n ${libdir} ]] ; then
1425 local var
1426 if [[ ${CHOST} == *-darwin* ]] ; then
1427 var=DYLD_LIBRARY_PATH
1428 else
1429 var=LD_LIBRARY_PATH
1430 fi
1431 cat <<-EOF
1432 if [ "\${${var}+set}" = "set" ] ; then
1433 export ${var}="\${${var}}:${EPREFIX}${libdir}"
1434 else
1435 export ${var}="${EPREFIX}${libdir}"
1436 fi
1437 EOF
1438 fi
1805 # We don't want to quote ${bin} so that people can pass complex 1439 # We don't want to quote ${bin} so that people can pass complex
1806 # things as $bin ... "./someprog --args" 1440 # things as ${bin} ... "./someprog --args"
1441 printf 'exec %s "$@"\n' "${bin/#\//${EPREFIX}\/}"
1807 cat << EOF > "${tmpwrapper}" 1442 ) > "${tmpwrapper}"
1808#!/bin/sh
1809cd "${chdir:-.}"
1810if [ -n "${libdir}" ] ; then
1811 if [ "\${LD_LIBRARY_PATH+set}" = "set" ] ; then
1812 export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}"
1813 else
1814 export LD_LIBRARY_PATH="${libdir}"
1815 fi
1816fi
1817exec ${bin} "\$@"
1818EOF
1819 chmod go+rx "${tmpwrapper}" 1443 chmod go+rx "${tmpwrapper}"
1444
1820 if [[ -n ${path} ]] ; then 1445 if [[ -n ${path} ]] ; then
1821 ( 1446 (
1822 exeinto "${path}" 1447 exeinto "${path}"
1823 newexe "${tmpwrapper}" "${wrapper}" 1448 newexe "${tmpwrapper}" "${wrapper}"
1824 ) || die 1449 ) || die
1825 else 1450 else
1826 newbin "${tmpwrapper}" "${wrapper}" || die 1451 newbin "${tmpwrapper}" "${wrapper}" || die
1827 fi 1452 fi
1828} 1453}
1829 1454
1830# @FUNCTION: prepalldocs 1455# @FUNCTION: path_exists
1831# @USAGE: 1456# @USAGE: [-a|-o] <paths>
1832# @DESCRIPTION: 1457# @DESCRIPTION:
1833# Compress files in /usr/share/doc which are not already 1458# Check if the specified paths exist. Works for all types of paths
1834# compressed, excluding /usr/share/doc/${PF}/html. 1459# (files/dirs/etc...). The -a and -o flags control the requirements
1835# Uses the ecompressdir to do the compression. 1460# of the paths. They correspond to "and" and "or" logic. So the -a
1836# 2009-02-18 by betelgeuse: 1461# flag means all the paths must exist while the -o flag means at least
1837# Commented because ecompressdir is even more internal to 1462# one of the paths must exist. The default behavior is "and". If no
1838# Portage than prepalldocs (it's not even mentioned in man 5 1463# paths are specified, then the return value is "false".
1839# ebuild). Please submit a better version for review to gentoo-dev 1464path_exists() {
1840# if you want prepalldocs here. 1465 local opt=$1
1841#prepalldocs() { 1466 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1842# if [[ -n $1 ]] ; then 1467
1843# ewarn "prepalldocs: invalid usage; takes no arguments" 1468 # no paths -> return false
1469 # same behavior as: [[ -e "" ]]
1470 [[ $# -eq 0 ]] && return 1
1471
1472 local p r=0
1473 for p in "$@" ; do
1474 [[ -e ${p} ]]
1475 : $(( r += $? ))
1476 done
1477
1478 case ${opt} in
1479 -a) return $(( r != 0 )) ;;
1480 -o) return $(( r == $# )) ;;
1481 esac
1482}
1483
1484# @FUNCTION: in_iuse
1485# @USAGE: <flag>
1486# @DESCRIPTION:
1487# Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1488# as necessary.
1489#
1490# Note that this function should not be used in the global scope.
1491in_iuse() {
1492 debug-print-function ${FUNCNAME} "${@}"
1493 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1494
1495 local flag=${1}
1496 local liuse=( ${IUSE} )
1497
1498 has "${flag}" "${liuse[@]#[+-]}"
1499}
1500
1501# @FUNCTION: use_if_iuse
1502# @USAGE: <flag>
1503# @DESCRIPTION:
1504# Return true if the given flag is in USE and IUSE.
1505#
1506# Note that this function should not be used in the global scope.
1507use_if_iuse() {
1508 in_iuse $1 || return 1
1509 use $1
1510}
1511
1512# @FUNCTION: usex
1513# @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1514# @DESCRIPTION:
1515# Proxy to declare usex for package managers or EAPIs that do not provide it
1516# and use the package manager implementation when available (i.e. EAPI >= 5).
1517# If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1518# otherwise echo [false output][false suffix] (defaults to "no").
1519if has "${EAPI:-0}" 0 1 2 3 4; then
1520 usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963
1521fi
1522
1523# @FUNCTION: prune_libtool_files
1524# @USAGE: [--all|--modules]
1525# @DESCRIPTION:
1526# Locate unnecessary libtool files (.la) and libtool static archives
1527# (.a) and remove them from installation image.
1528#
1529# By default, .la files are removed whenever the static linkage can
1530# either be performed using pkg-config or doesn't introduce additional
1531# flags.
1532#
1533# If '--modules' argument is passed, .la files for modules (plugins) are
1534# removed as well. This is usually useful when the package installs
1535# plugins and the plugin loader does not use .la files.
1536#
1537# If '--all' argument is passed, all .la files are removed without
1538# performing any heuristic on them. You shouldn't ever use that,
1539# and instead report a bug in the algorithm instead.
1540#
1541# The .a files are only removed whenever corresponding .la files state
1542# that they should not be linked to, i.e. whenever these files
1543# correspond to plugins.
1544#
1545# Note: if your package installs both static libraries and .pc files
1546# which use variable substitution for -l flags, you need to add
1547# pkg-config to your DEPEND.
1548prune_libtool_files() {
1549 debug-print-function ${FUNCNAME} "$@"
1550
1551 local removing_all removing_modules opt
1552 _eutils_eprefix_init
1553 for opt; do
1554 case "${opt}" in
1555 --all)
1556 removing_all=1
1557 removing_modules=1
1558 ;;
1559 --modules)
1560 removing_modules=1
1561 ;;
1562 *)
1563 die "Invalid argument to ${FUNCNAME}(): ${opt}"
1564 esac
1565 done
1566
1567 local f
1568 local queue=()
1569 while IFS= read -r -d '' f; do # for all .la files
1570 local archivefile=${f/%.la/.a}
1571
1572 # The following check is done by libtool itself.
1573 # It helps us avoid removing random files which match '*.la',
1574 # see bug #468380.
1575 if ! sed -n -e '/^# Generated by .*libtool/q0;4q1' "${f}"; then
1576 continue
1577 fi
1578
1579 [[ ${f} != ${archivefile} ]] || die 'regex sanity check failed'
1580 local reason pkgconfig_scanned
1581 local snotlink=$(sed -n -e 's:^shouldnotlink=::p' "${f}")
1582
1583 if [[ ${snotlink} == yes ]]; then
1584
1585 # Remove static libs we're not supposed to link against.
1586 if [[ -f ${archivefile} ]]; then
1587 einfo "Removing unnecessary ${archivefile#${D%/}} (static plugin)"
1588 queue+=( "${archivefile}" )
1589 fi
1590
1591 # The .la file may be used by a module loader, so avoid removing it
1592 # unless explicitly requested.
1593 if [[ ${removing_modules} ]]; then
1594 reason='module'
1595 fi
1596
1597 else
1598
1599 # Remove .la files when:
1600 # - user explicitly wants us to remove all .la files,
1601 # - respective static archive doesn't exist,
1602 # - they are covered by a .pc file already,
1603 # - they don't provide any new information (no libs & no flags).
1604
1605 if [[ ${removing_all} ]]; then
1606 reason='requested'
1607 elif [[ ! -f ${archivefile} ]]; then
1608 reason='no static archive'
1609 elif [[ ! $(sed -nre \
1610 "s/^(dependency_libs|inherited_linker_flags)='(.*)'$/\2/p" \
1611 "${f}") ]]; then
1612 reason='no libs & flags'
1613 else
1614 if [[ ! ${pkgconfig_scanned} ]]; then
1615 # Create a list of all .pc-covered libs.
1616 local pc_libs=()
1617 if [[ ! ${removing_all} ]]; then
1618 local pc
1619 local tf=${T}/prune-lt-files.pc
1620 local pkgconf=$(tc-getPKG_CONFIG)
1621
1622 while IFS= read -r -d '' pc; do # for all .pc files
1623 local arg libs
1624
1625 # Use pkg-config if available (and works),
1626 # fallback to sed.
1627 if ${pkgconf} --exists "${pc}" &>/dev/null; then
1628 sed -e '/^Requires:/d' "${pc}" > "${tf}"
1629 libs=$(${pkgconf} --libs "${tf}")
1630 else
1631 libs=$(sed -ne 's/^Libs://p' "${pc}")
1632 fi
1633
1634 for arg in ${libs}; do
1635 if [[ ${arg} == -l* ]]; then
1636 if [[ ${arg} == '*$*' ]]; then
1637 eqawarn "${FUNCNAME}: variable substitution likely failed in ${pc}"
1638 eqawarn "(arg: ${arg})"
1639 eqawarn "Most likely, you need to add virtual/pkgconfig to DEPEND."
1640 fi
1641
1642 pc_libs+=( lib${arg#-l}.la )
1643 fi
1644 done
1645 done < <(find "${D}" -type f -name '*.pc' -print0)
1646
1647 rm -f "${tf}"
1648 fi
1649
1650 pkgconfig_scanned=1
1651 fi # pkgconfig_scanned
1652
1653 has "${f##*/}" "${pc_libs[@]}" && reason='covered by .pc'
1654 fi # removal due to .pc
1655
1656 fi # shouldnotlink==no
1657
1658 if [[ ${reason} ]]; then
1659 einfo "Removing unnecessary ${f#${D%/}} (${reason})"
1660 queue+=( "${f}" )
1661 fi
1662 done < <(find "${ED}" -xtype f -name '*.la' -print0)
1663
1664 if [[ ${queue[@]} ]]; then
1665 rm -f "${queue[@]}"
1844# fi 1666 fi
1667}
1845 1668
1846# cd "${D}" 1669# @FUNCTION: prune_libtool_files
1847# [[ -d usr/share/doc ]] || return 0 1670# @DESCRIPTION:
1671# Install documentation using DOCS and HTML_DOCS.
1672#
1673# If DOCS is declared and non-empty, all files listed in it are
1674# installed. The files must exist, otherwise the function will fail.
1675# In EAPI 4 and subsequent EAPIs DOCS may specify directories as well,
1676# in other EAPIs using directories is unsupported.
1677#
1678# If DOCS is not declared, the files matching patterns given
1679# in the default EAPI implementation of src_install will be installed.
1680# If this is undesired, DOCS can be set to empty value to prevent any
1681# documentation from being installed.
1682#
1683# If HTML_DOCS is declared and non-empty, all files and/or directories
1684# listed in it are installed as HTML docs (using dohtml).
1685#
1686# Both DOCS and HTML_DOCS can either be an array or a whitespace-
1687# separated list. Whenever directories are allowed, '<directory>/.' may
1688# be specified in order to install all files within the directory
1689# without creating a sub-directory in docdir.
1690#
1691# Passing additional options to dodoc and dohtml is not supported.
1692# If you needed such a thing, you need to call those helpers explicitly.
1693einstalldocs() {
1694 debug-print-function ${FUNCNAME} "${@}"
1848 1695
1849# find usr/share/doc -exec gzip {} + 1696 local dodoc_opts=-r
1850# ecompressdir --ignore /usr/share/doc/${PF}/html 1697 has ${EAPI} 0 1 2 3 && dodoc_opts=
1851# ecompressdir --queue /usr/share/doc 1698
1852#} 1699 if ! declare -p DOCS &>/dev/null ; then
1700 local d
1701 for d in README* ChangeLog AUTHORS NEWS TODO CHANGES \
1702 THANKS BUGS FAQ CREDITS CHANGELOG ; do
1703 if [[ -s ${d} ]] ; then
1704 dodoc "${d}" || die
1705 fi
1706 done
1707 elif [[ $(declare -p DOCS) == "declare -a"* ]] ; then
1708 if [[ ${DOCS[@]} ]] ; then
1709 dodoc ${dodoc_opts} "${DOCS[@]}" || die
1710 fi
1711 else
1712 if [[ ${DOCS} ]] ; then
1713 dodoc ${dodoc_opts} ${DOCS} || die
1714 fi
1715 fi
1716
1717 if [[ $(declare -p HTML_DOCS 2>/dev/null) == "declare -a"* ]] ; then
1718 if [[ ${HTML_DOCS[@]} ]] ; then
1719 dohtml -r "${HTML_DOCS[@]}" || die
1720 fi
1721 else
1722 if [[ ${HTML_DOCS} ]] ; then
1723 dohtml -r ${HTML_DOCS} || die
1724 fi
1725 fi
1726
1727 return 0
1728}
1729
1730check_license() { die "you no longer need this as portage supports ACCEPT_LICENSE itself"; }
1731
1732fi

Legend:
Removed from v.1.315  
changed lines
  Added in v.1.429

  ViewVC Help
Powered by ViewVC 1.1.20